text \<open>Trivialities\<close>
theory Basic_Utils
  imports TRS.Trs
begin

lemmas construct_exI' = Ex_list_of_length_P

lemma construct_exI'_double:
  assumes "\<forall>i < n. \<exists>x y. P x y i"
  shows "\<exists>xs ys. length xs = n \<and> length ys = n \<and> (\<forall>i < n. P (xs ! i) (ys ! i) i)"
proof -
  from assms obtain f g where "P (f i) (g i) i" if "i < n" for i using assms by metis
  then show ?thesis by (intro exI[of _ "map _ [0..<n]"]) auto
qed

(* TODO: check whether this is still needed *)
lemma construct_exI:
  assumes "\<forall>i < n. \<exists>xs. P (xs ! i) i"
  shows "\<exists>xs. length xs = n \<and> (\<forall>i < n. P (xs ! i) i)"
proof -
  guess xss using construct_exI'[OF assms] by (elim exE)
  then show ?thesis by (intro exI[of _ "map (\<lambda>i. xss ! i ! i) [0..<n]"]) auto
qed

definition right_ground_trs :: "('f, 'v) trs \<Rightarrow> bool" where
  "right_ground_trs R \<equiv> \<forall>(l, r) \<in> R. ground r"

definition ground_trs :: "('f, 'v) trs \<Rightarrow> bool" where
  "ground_trs R \<equiv> \<forall>(l, r) \<in> R. ground l \<and> ground r"

lemma ground_imp_right_ground_trs [simp]:
  "ground_trs R \<Longrightarrow> right_ground_trs R"
  unfolding ground_trs_def right_ground_trs_def by fast

definition set_to_list :: "'a set \<Rightarrow> 'a list"
  where "set_to_list s = (SOME l. set l = s)"

lemma set_set_to_list:
  "finite s \<Longrightarrow> set (set_to_list s) = s"
  unfolding set_to_list_def by (metis (mono_tags) finite_list some_eq_ex)

end
