{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module
  GCR(Nat, Ordera, Compare_order, Term(..), Sum, Ta_rule, Rbta, Set(..),
       Dres(..), Ta_list, Answer(..), Xoption, funas_trs, nat_of_integer,
       rec_term, tal_size, ta_size_rbt, cr_procedure, llrg_cr_procedure_wrap,
       lv_gcr_procedure_wrap)
  where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;
import qualified Uint;
import qualified Array;
import qualified Uint32;
import qualified Data_Bits;

newtype Nat = Nat Integer;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

instance Eq Nat where {
  a == b = equal_nat a b;
};

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

class Zero a where {
  zero :: a;
};

instance Zero Nat where {
  zero = zero_nat;
};

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat m n = integer_of_nat m <= integer_of_nat n;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

data Ordera = Eqa | Lt | Gt;

class (Ord a) => Preorder a where {
};

class (Preorder a) => Order a where {
};

class (Order a) => Linorder a where {
};

comparator_of :: forall a. (Eq a, Linorder a) => a -> a -> Ordera;
comparator_of x y = (if less x y then Lt else (if x == y then Eqa else Gt));

instance Preorder Nat where {
};

instance Order Nat where {
};

instance Linorder Nat where {
};

compare_nat :: Nat -> Nat -> Ordera;
compare_nat = comparator_of;

class Compare a where {
  compare :: a -> a -> Ordera;
};

instance Compare Nat where {
  compare = compare_nat;
};

newtype Phantom a b = Phantom b;

finite_UNIV_nat :: Phantom Nat Bool;
finite_UNIV_nat = Phantom False;

card_UNIV_nat :: Phantom Nat Nat;
card_UNIV_nat = Phantom zero_nat;

class Finite_UNIV a where {
  finite_UNIV :: Phantom a Bool;
};

class (Finite_UNIV a) => Card_UNIV a where {
  card_UNIV :: Phantom a Nat;
};

instance Finite_UNIV Nat where {
  finite_UNIV = finite_UNIV_nat;
};

instance Card_UNIV Nat where {
  card_UNIV = card_UNIV_nat;
};

class (Compare a, Linorder a) => Compare_order a where {
};

instance Compare_order Nat where {
};

less_eq_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_eq_list (x : xs) (y : ys) = less x y || x == y && less_eq_list xs ys;
less_eq_list [] xs = True;
less_eq_list (x : xs) [] = False;

less_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_list (x : xs) (y : ys) = less x y || x == y && less_list xs ys;
less_list [] (x : xs) = True;
less_list xs [] = False;

instance (Eq a, Order a) => Ord [a] where {
  less_eq = less_eq_list;
  less = less_list;
};

comparator_list :: forall a. (a -> a -> Ordera) -> [a] -> [a] -> Ordera;
comparator_list comp_a (x : xa) (y : ya) =
  (case comp_a x y of {
    Eqa -> comparator_list comp_a xa ya;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_list comp_a (x : xa) [] = Gt;
comparator_list comp_a [] (y : ya) = Lt;
comparator_list comp_a [] [] = Eqa;

compare_list :: forall a. (Compare a) => [a] -> [a] -> Ordera;
compare_list = comparator_list compare;

instance (Compare a) => Compare [a] where {
  compare = compare_list;
};

instance (Eq a, Order a) => Preorder [a] where {
};

instance (Eq a, Order a) => Order [a] where {
};

instance (Eq a, Linorder a) => Linorder [a] where {
};

finite_UNIV_list :: forall a. Phantom [a] Bool;
finite_UNIV_list = Phantom False;

card_UNIV_list :: forall a. Phantom [a] Nat;
card_UNIV_list = Phantom zero_nat;

instance Finite_UNIV [a] where {
  finite_UNIV = finite_UNIV_list;
};

instance Card_UNIV [a] where {
  card_UNIV = card_UNIV_list;
};

instance (Compare_order a, Eq a) => Compare_order [a] where {
};

data Term a b = Var b | Fun a [Term a b];

instance (Eq a, Eq b) => Eq (Term a b) where {
  a == b = equal_term a b;
};

equal_term :: forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Bool;
equal_term (Var x1) (Fun x21 x22) = False;
equal_term (Fun x21 x22) (Var x1) = False;
equal_term (Fun x21 x22) (Fun y21 y22) = x21 == y21 && x22 == y22;
equal_term (Var x1) (Var y1) = x1 == y1;

comparator_term ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> Term a b -> Term a b -> Ordera;
comparator_term comp_f comp_v (Fun x xa) (Fun ya yb) =
  (case comp_f x ya of {
    Eqa -> comparator_list (comparator_term comp_f comp_v) xa yb;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_term comp_f comp_v (Fun x xa) (Var y) = Gt;
comparator_term comp_f comp_v (Var x) (Fun ya yb) = Lt;
comparator_term comp_f comp_v (Var x) (Var y) = comp_v x y;

compare_term ::
  forall a b. (Compare a, Compare b) => Term a b -> Term a b -> Ordera;
compare_term = comparator_term compare compare;

le_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
le_of_comp acomp x y = (case acomp x y of {
                         Eqa -> True;
                         Lt -> True;
                         Gt -> False;
                       });

less_eq_term ::
  forall a b. (Compare a, Compare b) => Term a b -> Term a b -> Bool;
less_eq_term = le_of_comp compare_term;

lt_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
lt_of_comp acomp x y = (case acomp x y of {
                         Eqa -> False;
                         Lt -> True;
                         Gt -> False;
                       });

less_term :: forall a b. (Compare a, Compare b) => Term a b -> Term a b -> Bool;
less_term = lt_of_comp compare_term;

instance (Compare a, Compare b) => Ord (Term a b) where {
  less_eq = less_eq_term;
  less = less_term;
};

instance (Compare a, Compare b) => Compare (Term a b) where {
  compare = compare_term;
};

instance (Compare a, Compare b) => Preorder (Term a b) where {
};

instance (Compare a, Compare b) => Order (Term a b) where {
};

instance (Compare a, Compare b) => Linorder (Term a b) where {
};

instance (Compare a, Compare b) => Compare_order (Term a b) where {
};

data Sum a b = Inl a | Inr b;

equal_sum :: forall a b. (Eq a, Eq b) => Sum a b -> Sum a b -> Bool;
equal_sum (Inl x1) (Inr x2) = False;
equal_sum (Inr x2) (Inl x1) = False;
equal_sum (Inr x2) (Inr y2) = x2 == y2;
equal_sum (Inl x1) (Inl y1) = x1 == y1;

instance (Eq a, Eq b) => Eq (Sum a b) where {
  a == b = equal_sum a b;
};

comparator_sum ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> Sum a b -> Sum a b -> Ordera;
comparator_sum comp_a comp_b (Inr x) (Inr ya) = comp_b x ya;
comparator_sum comp_a comp_b (Inr x) (Inl y) = Gt;
comparator_sum comp_a comp_b (Inl x) (Inr ya) = Lt;
comparator_sum comp_a comp_b (Inl x) (Inl y) = comp_a x y;

compare_sum ::
  forall a b. (Compare a, Compare b) => Sum a b -> Sum a b -> Ordera;
compare_sum = comparator_sum compare compare;

less_eq_sum :: forall a b. (Compare a, Compare b) => Sum a b -> Sum a b -> Bool;
less_eq_sum = le_of_comp compare_sum;

less_sum :: forall a b. (Compare a, Compare b) => Sum a b -> Sum a b -> Bool;
less_sum = lt_of_comp compare_sum;

instance (Compare a, Compare b) => Ord (Sum a b) where {
  less_eq = less_eq_sum;
  less = less_sum;
};

instance (Compare a, Compare b) => Compare (Sum a b) where {
  compare = compare_sum;
};

instance (Compare a, Compare b) => Preorder (Sum a b) where {
};

instance (Compare a, Compare b) => Order (Sum a b) where {
};

instance (Compare a, Compare b) => Linorder (Sum a b) where {
};

instance (Compare a, Compare b) => Compare_order (Sum a b) where {
};

less_eq_option :: forall a. (Preorder a) => Maybe a -> Maybe a -> Bool;
less_eq_option (Just x) (Just y) = less_eq x y;
less_eq_option (Just x) Nothing = False;
less_eq_option Nothing x = True;

less_option :: forall a. (Preorder a) => Maybe a -> Maybe a -> Bool;
less_option (Just x) (Just y) = less x y;
less_option Nothing (Just x) = True;
less_option x Nothing = False;

instance (Preorder a) => Ord (Maybe a) where {
  less_eq = less_eq_option;
  less = less_option;
};

comparator_option ::
  forall a. (a -> a -> Ordera) -> Maybe a -> Maybe a -> Ordera;
comparator_option comp_a (Just x) (Just y) = comp_a x y;
comparator_option comp_a (Just x) Nothing = Gt;
comparator_option comp_a Nothing (Just y) = Lt;
comparator_option comp_a Nothing Nothing = Eqa;

compare_option :: forall a. (Compare a) => Maybe a -> Maybe a -> Ordera;
compare_option = comparator_option compare;

instance (Compare a) => Compare (Maybe a) where {
  compare = compare_option;
};

instance (Preorder a) => Preorder (Maybe a) where {
};

instance (Order a) => Order (Maybe a) where {
};

instance (Linorder a) => Linorder (Maybe a) where {
};

instance (Compare_order a) => Compare_order (Maybe a) where {
};

less_eq_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_eq_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less_eq y1 y2;

less_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less y1 y2;

instance (Ord a, Ord b) => Ord (a, b) where {
  less_eq = less_eq_prod;
  less = less_prod;
};

comparator_prod ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> (a, b) -> (a, b) -> Ordera;
comparator_prod comp_a comp_b (x, xa) (y, ya) = (case comp_a x y of {
          Eqa -> comp_b xa ya;
          Lt -> Lt;
          Gt -> Gt;
        });

compare_prod ::
  forall a b. (Compare a, Compare b) => (a, b) -> (a, b) -> Ordera;
compare_prod = comparator_prod compare compare;

instance (Compare a, Compare b) => Compare (a, b) where {
  compare = compare_prod;
};

instance (Preorder a, Preorder b) => Preorder (a, b) where {
};

instance (Order a, Order b) => Order (a, b) where {
};

instance (Linorder a, Linorder b) => Linorder (a, b) where {
};

of_phantom :: forall a b. Phantom a b -> b;
of_phantom (Phantom x) = x;

finite_UNIV_prod ::
  forall a b. (Finite_UNIV a, Finite_UNIV b) => Phantom (a, b) Bool;
finite_UNIV_prod =
  Phantom
    (of_phantom (finite_UNIV :: Phantom a Bool) &&
      of_phantom (finite_UNIV :: Phantom b Bool));

times_nat :: Nat -> Nat -> Nat;
times_nat m n = Nat (integer_of_nat m * integer_of_nat n);

card_UNIV_prod :: forall a b. (Card_UNIV a, Card_UNIV b) => Phantom (a, b) Nat;
card_UNIV_prod =
  Phantom
    (times_nat (of_phantom (card_UNIV :: Phantom a Nat))
      (of_phantom (card_UNIV :: Phantom b Nat)));

instance (Finite_UNIV a, Finite_UNIV b) => Finite_UNIV (a, b) where {
  finite_UNIV = finite_UNIV_prod;
};

instance (Card_UNIV a, Card_UNIV b) => Card_UNIV (a, b) where {
  card_UNIV = card_UNIV_prod;
};

instance (Compare_order a, Compare_order b) => Compare_order (a, b) where {
};

comparator_unit :: () -> () -> Ordera;
comparator_unit x y = Eqa;

compare_unit :: () -> () -> Ordera;
compare_unit = comparator_unit;

instance Compare () where {
  compare = compare_unit;
};

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

data Ta_rule a b = TA_rule b [a] a;

equal_ta_rule :: forall a b. (Eq a, Eq b) => Ta_rule a b -> Ta_rule a b -> Bool;
equal_ta_rule (TA_rule x1 x2 x3) (TA_rule y1 y2 y3) =
  x1 == y1 && x2 == y2 && x3 == y3;

instance (Eq a, Eq b) => Eq (Ta_rule a b) where {
  a == b = equal_ta_rule a b;
};

comparator_ta_rule ::
  forall a b.
    (a -> a -> Ordera) ->
      (b -> b -> Ordera) -> Ta_rule a b -> Ta_rule a b -> Ordera;
comparator_ta_rule comp_q comp_f (TA_rule x xa xb) (TA_rule y ya yb) =
  (case comp_f x y of {
    Eqa -> (case comparator_list comp_q xa ya of {
             Eqa -> comp_q xb yb;
             Lt -> Lt;
             Gt -> Gt;
           });
    Lt -> Lt;
    Gt -> Gt;
  });

compare_ta_rule ::
  forall a b. (Compare a, Compare b) => Ta_rule a b -> Ta_rule a b -> Ordera;
compare_ta_rule = comparator_ta_rule compare compare;

less_eq_ta_rule ::
  forall a b. (Compare a, Compare b) => Ta_rule a b -> Ta_rule a b -> Bool;
less_eq_ta_rule = le_of_comp compare_ta_rule;

less_ta_rule ::
  forall a b. (Compare a, Compare b) => Ta_rule a b -> Ta_rule a b -> Bool;
less_ta_rule = lt_of_comp compare_ta_rule;

instance (Compare a, Compare b) => Ord (Ta_rule a b) where {
  less_eq = less_eq_ta_rule;
  less = less_ta_rule;
};

instance (Compare a, Compare b) => Compare (Ta_rule a b) where {
  compare = compare_ta_rule;
};

instance (Compare a, Compare b) => Preorder (Ta_rule a b) where {
};

instance (Compare a, Compare b) => Order (Ta_rule a b) where {
};

instance (Compare a, Compare b) => Linorder (Ta_rule a b) where {
};

instance (Compare a, Compare b) => Compare_order (Ta_rule a b) where {
};

data Num = One | Bit0 Num | Bit1 Num;

data Color = R | B;

data Rbta a b = Empty | Branch Color (Rbta a b) a b (Rbta a b);

newtype Rbt b a = RBT (Rbta b a);

data Set a = Set [a] | Coset [a];

data Dres a = DSUCCEEDi | DFAILi | DRETURN a;

data Ta_list a b = Ta_list [a] [Ta_rule a b] [(a, a)];

data Comparea = LT | GT | EQ;

data Comp_res = LESS | EQUAL | GREATER;

data Ctxt a b = Hole | More a [Term a b] (Ctxt a b) [Term a b];

data Answer = YES | NO | MAYBE;

data Xoption a = XNone | XSome a;

data Status a b = Done (Xoption (Term a b)) | Changed | Unchanged;

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n zero_nat then x else nth xs (minus_nat n one_nat));

upt :: Nat -> Nat -> [Nat];
upt i j = (if less_nat i j then i : upt (suc i) j else []);

ball :: forall a. Set a -> (a -> Bool) -> Bool;
ball (Set xs) p = all p xs;

fold :: forall a b. (a -> b -> b) -> [a] -> b -> b;
fold f (x : xs) s = fold f xs (f x s);
fold f [] s = s;

empty :: forall a b. (Linorder a) => Rbt a b;
empty = RBT Empty;

image :: forall a b. (a -> b) -> Set a -> Set b;
image f (Set xs) = Set (map f xs);

foldl :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldl f a [] = a;
foldl f a (x : xs) = foldl f (f a x) xs;

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

balance :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Empty =
  Branch R (Branch B a w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Empty w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch R Empty w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Empty w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Empty w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance Empty w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Empty s t Empty = Branch B Empty s t Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance Empty s t (Branch v Empty vb vc Empty) =
  Branch B Empty s t (Branch v Empty vb vc Empty);
balance Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty) =
  Branch B Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty);
balance Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi))
  = Branch B Empty s t
      (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v (Branch B vi vj vk vl) vf vg Empty)
  = Branch B (Branch B va vb vc vd) s t
      (Branch v (Branch B vi vj vk vl) vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg (Branch B vj vk vl vm))
  = Branch B (Branch B va vb vc vd) s t
      (Branch v Empty vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance (Branch v Empty vb vc Empty) s t Empty =
  Branch B (Branch v Empty vb vc Empty) s t Empty;
balance (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty =
  Branch B (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t Empty
  = Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
      Empty;
balance (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd) =
  Branch B (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg (Branch B vi vj vk vl)) s t (Branch B va vb vc vd)
  = Branch B (Branch v Empty vf vg (Branch B vi vj vk vl)) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Empty) s t (Branch B va vb vc vd)
  = Branch B (Branch v (Branch B vj vk vl vm) vf vg Empty) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

rbt_insa ::
  forall a b.
    (Compare_order a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insa f k v (Branch R l x y r) = (case compare k x of {
                                      Eqa -> Branch R l x (f k y v) r;
                                      Lt -> Branch R (rbt_insa f k v l) x y r;
                                      Gt -> Branch R l x y (rbt_insa f k v r);
                                    });
rbt_insa f k v (Branch B l x y r) = (case compare k x of {
                                      Eqa -> Branch B l x (f k y v) r;
                                      Lt -> balance (rbt_insa f k v l) x y r;
                                      Gt -> balance l x y (rbt_insa f k v r);
                                    });
rbt_insa f k v Empty = Branch R Empty k v Empty;

paint :: forall a b. Color -> Rbta a b -> Rbta a b;
paint c Empty = Empty;
paint c (Branch uu l k v r) = Branch c l k v r;

rbt_insert_with_keya ::
  forall a b.
    (Compare_order a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_keya f k v t = paint B (rbt_insa f k v t);

rbt_inserta :: forall a b. (Compare_order a) => a -> b -> Rbta a b -> Rbta a b;
rbt_inserta = rbt_insert_with_keya (\ _ _ nv -> nv);

impl_of :: forall b a. (Linorder b) => Rbt b a -> Rbta b a;
impl_of (RBT x) = x;

insert :: forall a b. (Compare_order a) => a -> b -> Rbt a b -> Rbt a b;
insert xc xd xe = RBT (rbt_inserta xc xd (impl_of xe));

rbt_lookupa :: forall a b. (Compare_order a) => Rbta a b -> a -> Maybe b;
rbt_lookupa (Branch uu l x y r) k = (case compare k x of {
                                      Eqa -> Just y;
                                      Lt -> rbt_lookupa l k;
                                      Gt -> rbt_lookupa r k;
                                    });
rbt_lookupa Empty k = Nothing;

lookup :: forall a b. (Compare_order a) => Rbt a b -> a -> Maybe b;
lookup x = rbt_lookupa (impl_of x);

removeAll :: forall a. (Eq a) => a -> [a] -> [a];
removeAll x [] = [];
removeAll x (y : xs) = (if x == y then removeAll x xs else y : removeAll x xs);

membera :: forall a. (Eq a) => [a] -> a -> Bool;
membera [] y = False;
membera (x : xs) y = x == y || membera xs y;

insertb :: forall a. (Eq a) => a -> [a] -> [a];
insertb x xs = (if membera xs x then xs else x : xs);

inserta :: forall a. (Eq a) => a -> Set a -> Set a;
inserta x (Coset xs) = Coset (removeAll x xs);
inserta x (Set xs) = Set (insertb x xs);

member :: forall a. (Eq a) => a -> Set a -> Bool;
member x (Coset xs) = not (membera xs x);
member x (Set xs) = membera xs x;

const :: forall a b. a -> b -> a;
const = (\ x _ -> x);

bind :: forall a b. Maybe a -> (a -> Maybe b) -> Maybe b;
bind Nothing f = Nothing;
bind (Just x) f = f x;

foldli :: forall a b. [a] -> (b -> Bool) -> (a -> b -> b) -> b -> b;
foldli [] c f sigma = sigma;
foldli (x : xs) c f sigma =
  (if c sigma then foldli xs c f (f x sigma) else sigma);

product :: forall a b. [a] -> [b] -> [(a, b)];
product [] uu = [];
product (x : xs) ys = map (\ a -> (x, a)) ys ++ product xs ys;

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if membera xs x then remdups xs else x : remdups xs);

mapa :: forall a b c. (a -> b -> c) -> Rbta a b -> Rbta a c;
mapa f Empty = Empty;
mapa f (Branch c lt k v rt) = Branch c (mapa f lt) k (f k v) (mapa f rt);

folda :: forall a b c. (a -> b -> c -> c) -> Rbta a b -> c -> c;
folda f (Branch c lt k v rt) x = folda f rt (f k v (folda f lt x));
folda f Empty x = x;

gen_keys :: forall a b. [(a, Rbta a b)] -> Rbta a b -> [a];
gen_keys kts (Branch c l k v r) = gen_keys ((k, r) : kts) l;
gen_keys ((k, t) : kts) Empty = k : gen_keys kts t;
gen_keys [] Empty = [];

keys :: forall a b. Rbta a b -> [a];
keys = gen_keys [];

sup_set :: forall a. (Eq a) => Set a -> Set a -> Set a;
sup_set (Coset xs) a = Coset (filter (\ x -> not (member x a)) xs);
sup_set (Set xs) a = fold inserta xs a;

bot_set :: forall a. Set a;
bot_set = Set [];

sup_seta :: forall a. (Eq a) => Set (Set a) -> Set a;
sup_seta (Set xs) = fold sup_set xs bot_set;

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

funas_term :: forall a b. (Eq a) => Term a b -> Set (a, Nat);
funas_term (Var uu) = bot_set;
funas_term (Fun f ts) =
  sup_set (inserta (f, size_list ts) bot_set)
    (sup_seta (Set (map funas_term ts)));

funas_rule :: forall a b. (Eq a) => (Term a b, Term a b) -> Set (a, Nat);
funas_rule r = sup_set (funas_term (fst r)) (funas_term (snd r));

funas_trs :: forall a b. (Eq a) => Set (Term a b, Term a b) -> Set (a, Nat);
funas_trs r = sup_seta (image funas_rule r);

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n zero_nat then [] else x : replicate (minus_nat n one_nat) x);

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

gen_set :: forall a b. a -> (b -> a -> a) -> [b] -> a;
gen_set emp ins l = fold ins l emp;

map_filter :: forall a b. (a -> Maybe b) -> [a] -> [b];
map_filter f [] = [];
map_filter f (x : xs) = (case f x of {
                          Nothing -> map_filter f xs;
                          Just y -> y : map_filter f xs;
                        });

ground :: forall a b. Term a b -> Bool;
ground (Var x) = False;
ground (Fun f ts) = all ground ts;

gen_ball ::
  forall a b c d e.
    (a -> (b -> b) -> (c -> d -> Bool) -> Bool -> e) -> a -> (c -> Bool) -> e;
gen_ball it s p = it s (\ x -> x) (\ x _ -> p x) True;

gen_card ::
  forall a b c d e.
    (Zero d) => (a -> (b -> Bool) -> (c -> Nat -> Nat) -> d -> e) -> a -> e;
gen_card it s = it s (\ _ -> True) (\ _ -> suc) zero;

remdups_adj :: forall a. (Eq a) => [a] -> [a];
remdups_adj [] = [];
remdups_adj [x] = [x];
remdups_adj (x : y : xs) =
  (if x == y then remdups_adj (x : xs) else x : remdups_adj (y : xs));

gen_entries :: forall a b. [((a, b), Rbta a b)] -> Rbta a b -> [(a, b)];
gen_entries kvts (Branch c l k v r) = gen_entries (((k, v), r) : kvts) l;
gen_entries ((kv, t) : kvts) Empty = kv : gen_entries kvts t;
gen_entries [] Empty = [];

entries :: forall a b. Rbta a b -> [(a, b)];
entries = gen_entries [];

dbind :: forall a b. Dres a -> (a -> Dres b) -> Dres b;
dbind DFAILi f = DFAILi;
dbind DSUCCEEDi f = DSUCCEEDi;
dbind (DRETURN x) f = f x;

card :: forall a. (Card_UNIV a, Eq a) => Set a -> Nat;
card (Coset xs) =
  minus_nat (of_phantom (card_UNIV :: Phantom a Nat)) (size_list (remdups xs));
card (Set xs) = size_list (remdups xs);

gen_Sigma ::
  forall a b c d e f g h i j k l.
    (a -> (b -> Bool) -> (c -> d -> e) -> f -> g) ->
      (h -> (i -> Bool) -> (j -> k -> l) -> d -> e) ->
        f -> ((c, j) -> k -> l) -> a -> (c -> h) -> g;
gen_Sigma it1 it2 empX insX s1 f2 =
  it1 s1 (\ _ -> True) (\ x -> it2 (f2 x) (\ _ -> True) (\ y -> insX (x, y)))
    empX;

gen_image ::
  forall a b c d e f g h.
    (a -> (b -> Bool) -> (c -> d -> e) -> f -> g) ->
      f -> (h -> d -> e) -> (c -> h) -> a -> g;
gen_image it1 emp2 ins2 f s1 = it1 s1 (\ _ -> True) (\ x -> ins2 (f x)) emp2;

gen_inter ::
  forall a b c d e f g.
    (a -> (b -> Bool) -> (c -> d -> d) -> e -> f) ->
      (c -> g -> Bool) -> (c -> d -> d) -> e -> a -> g -> f;
gen_inter it1 memb2 ins3 empty3 s1 s2 =
  it1 s1 (\ _ -> True) (\ x s -> (if memb2 x s2 then ins3 x s else s)) empty3;

gen_union ::
  forall a b c d.
    (a -> (b -> Bool) -> (c -> d -> d) -> d -> d) ->
      (c -> d -> d) -> a -> d -> d;
gen_union it ins a b = it a (\ _ -> True) ins b;

comp2eq :: forall a b. (a -> b -> Comp_res) -> a -> b -> Bool;
comp2eq cmp a b = (case cmp a b of {
                    LESS -> False;
                    EQUAL -> True;
                    GREATER -> False;
                  });

comp2lt :: forall a b. (a -> b -> Comp_res) -> a -> b -> Bool;
comp2lt cmp a b = (case cmp a b of {
                    LESS -> True;
                    EQUAL -> False;
                    GREATER -> False;
                  });

the :: forall a. Maybe a -> a;
the (Just x2) = x2;

mapM :: forall a b. (a -> Maybe b) -> [a] -> Maybe [b];
mapM f [] = Just [];
mapM f (x : xs) = bind (f x) (\ y -> bind (mapM f xs) (\ ys -> Just (y : ys)));

skip_red :: forall a b. Rbta a b -> Rbta a b;
skip_red (Branch R l k v r) = l;
skip_red Empty = Empty;
skip_red (Branch B va vb vc vd) = Branch B va vb vc vd;

the_Var :: forall a b. Term a b -> b;
the_Var (Var x1) = x1;

sgn_integer :: Integer -> Integer;
sgn_integer k =
  (if k == (0 :: Integer) then (0 :: Integer)
    else (if k < (0 :: Integer) then (-1 :: Integer) else (1 :: Integer)));

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if l == (0 :: Integer) then ((0 :: Integer), k)
           else ((apsnd . (\ a b -> a * b)) . sgn_integer) l
                  (if sgn_integer k == sgn_integer l then divMod (abs k) (abs l)
                    else (case divMod (abs k) (abs l) of {
                           (r, s) ->
                             (if s == (0 :: Integer)
                               then (negate r, (0 :: Integer))
                               else (negate r - (1 :: Integer),
                                      Prelude.abs l - s));
                         }))));

modulo_integer :: Integer -> Integer -> Integer;
modulo_integer k l = snd (divmod_integer k l);

modulo_nat :: Nat -> Nat -> Nat;
modulo_nat m n = Nat (modulo_integer (integer_of_nat m) (integer_of_nat n));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

divide_nat :: Nat -> Nat -> Nat;
divide_nat m n = Nat (divide_integer (integer_of_nat m) (integer_of_nat n));

divmod_nat :: Nat -> Nat -> (Nat, Nat);
divmod_nat m n = (divide_nat m n, modulo_nat m n);

list_union :: forall a. (Eq a) => [a] -> [a] -> [a];
list_union [] ys = ys;
list_union (x : xs) ys = let {
                           zs = list_union xs ys;
                         } in (if membera zs x then zs else x : zs);

uniq_list :: forall a. (Eq a) => [a] -> [a];
uniq_list [] = [];
uniq_list (x : xs) = list_union [x] (uniq_list xs);

gen_filter ::
  forall a b c d e f.
    (a -> (b -> Bool) -> (c -> d -> d) -> e -> f) ->
      e -> (c -> d -> d) -> (c -> Bool) -> a -> f;
gen_filter it1 emp2 ins2 p s1 =
  it1 s1 (\ _ -> True) (\ x s -> (if p x then ins2 x s else s)) emp2;

rec_list :: forall a b. a -> (b -> [b] -> a -> a) -> [b] -> a;
rec_list f1 f2 [] = f1;
rec_list f1 f2 (x21 : x22) = f2 x21 x22 (rec_list f1 f2 x22);

product_lists :: forall a. [[a]] -> [[a]];
product_lists [] = [[]];
product_lists (xs : xss) =
  concatMap (\ x -> map (\ a -> x : a) (product_lists xss)) xs;

apfst :: forall a b c. (a -> b) -> (a, c) -> (b, c);
apfst f (x, y) = (f x, y);

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max (0 :: Integer) k);

rbtreeify_g :: forall a b. Nat -> [(a, b)] -> (Rbta a b, [(a, b)]);
rbtreeify_g n kvs =
  (if equal_nat n zero_nat || equal_nat n one_nat then (Empty, kvs)
    else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
           (na, r) ->
             (if equal_nat r zero_nat
               then (case rbtreeify_g na kvs of {
                      (t1, (k, v) : kvsa) ->
                        apfst (Branch B t1 k v) (rbtreeify_g na kvsa);
                    })
               else (case rbtreeify_f na kvs of {
                      (t1, (k, v) : kvsa) ->
                        apfst (Branch B t1 k v) (rbtreeify_g na kvsa);
                    }));
         }));

rbtreeify_f :: forall a b. Nat -> [(a, b)] -> (Rbta a b, [(a, b)]);
rbtreeify_f n kvs =
  (if equal_nat n zero_nat then (Empty, kvs)
    else (if equal_nat n one_nat
           then (case kvs of {
                  (k, v) : kvsa -> (Branch R Empty k v Empty, kvsa);
                })
           else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
                  (na, r) ->
                    (if equal_nat r zero_nat
                      then (case rbtreeify_f na kvs of {
                             (t1, (k, v) : kvsa) ->
                               apfst (Branch B t1 k v) (rbtreeify_g na kvsa);
                           })
                      else (case rbtreeify_f na kvs of {
                             (t1, (k, v) : kvsa) ->
                               apfst (Branch B t1 k v) (rbtreeify_f na kvsa);
                           }));
                })));

rbtreeify :: forall a b. [(a, b)] -> Rbta a b;
rbtreeify kvs = fst (rbtreeify_g (suc (size_list kvs)) kvs);

dWHILET :: forall a. (a -> Bool) -> (a -> Dres a) -> a -> Dres a;
dWHILET b f s = (if b s then dbind (f s) (dWHILET b f) else DRETURN s);

map_term :: forall a b c d. (a -> b) -> (c -> d) -> Term a c -> Term b d;
map_term f1 f2 (Var x1) = Var (f2 x1);
map_term f1 f2 (Fun x21 x22) = Fun (f1 x21) (map (map_term f1 f2) x22);

rec_term ::
  forall a b c. (a -> b) -> (c -> [(Term c a, b)] -> b) -> Term c a -> b;
rec_term f1 f2 (Var x1) = f1 x1;
rec_term f1 f2 (Fun x21 x22) =
  f2 x21 (map (\ term -> (term, rec_term f1 f2 term)) x22);

top_set :: forall a. Set a;
top_set = Coset [];

subset :: forall a. (Card_UNIV a, Eq a) => Set a -> Set a -> Bool;
subset (Coset xs) (Set ys) =
  let {
    n = (card :: Set a -> Nat) top_set;
  } in less_nat zero_nat n && equal_nat (card (Set (xs ++ ys))) n;
subset (Set ys) b = all (\ y -> member y b) ys;
subset a (Coset ys) = all (\ y -> not (member y a)) ys;

gen_isEmpty :: forall a b. (a -> (b -> Bool) -> Bool) -> a -> Bool;
gen_isEmpty ball s = ball s (\ _ -> False);

list_all2 :: forall a b. (a -> b -> Bool) -> [a] -> [b] -> Bool;
list_all2 p (x : xs) (y : ys) = p x y && list_all2 p xs ys;
list_all2 p xs [] = null xs;
list_all2 p [] ys = null ys;

skip_black :: forall a b. Rbta a b -> Rbta a b;
skip_black t = let {
                 ta = skip_red t;
               } in (case ta of {
                      Empty -> ta;
                      Branch R _ _ _ _ -> ta;
                      Branch B l _ _ _ -> l;
                    });

r_sym :: forall a b. Ta_rule a b -> (b, Nat);
r_sym (TA_rule f qs q) = (f, size_list qs);

add_funas_term :: forall a b. Term a b -> [(a, Nat)] -> [(a, Nat)];
add_funas_term (Var uu) fs = fs;
add_funas_term (Fun f ts) fs = (f, size_list ts) : foldr add_funas_term ts fs;

add_funas_rule :: forall a b. (Term a b, Term a b) -> [(a, Nat)] -> [(a, Nat)];
add_funas_rule r fs = add_funas_term (fst r) (add_funas_term (snd r) fs);

funas_rule_list :: forall a b. (Term a b, Term a b) -> [(a, Nat)];
funas_rule_list r = add_funas_rule r [];

linear_term_impl :: forall a b. (Eq a) => Set a -> Term b a -> Maybe (Set a);
linear_term_impl xs (Var x) =
  (if member x xs then Nothing else Just (inserta x xs));
linear_term_impl xs (Fun uu []) = Just xs;
linear_term_impl xs (Fun f (t : ts)) =
  (case linear_term_impl xs t of {
    Nothing -> Nothing;
    Just ys -> linear_term_impl ys (Fun f ts);
  });

linear_term :: forall a b. (Eq b) => Term a b -> Bool;
linear_term t = not (is_none (linear_term_impl bot_set t));

left_linear_trs :: forall a b. (Eq b) => Set (Term a b, Term a b) -> Bool;
left_linear_trs r = ball r (\ (l, _) -> linear_term l);

gen_disjoint ::
  forall a b c d e f.
    (a -> (b -> b) -> (c -> d -> Bool) -> Bool -> e) ->
      (c -> f -> Bool) -> a -> f -> e;
gen_disjoint it1 mem2 s1 s2 = it1 s1 (\ x -> x) (\ x _ -> not (mem2 x s2)) True;

rbt_ins ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_ins less f k v (Branch R l x y r) =
  (if less k x then Branch R (rbt_ins less f k v l) x y r
    else (if less x k then Branch R l x y (rbt_ins less f k v r)
           else Branch R l x (f k y v) r));
rbt_ins less f k v (Branch B l x y r) =
  (if less k x then balance (rbt_ins less f k v l) x y r
    else (if less x k then balance l x y (rbt_ins less f k v r)
           else Branch B l x (f k y v) r));
rbt_ins less f k v Empty = Branch R Empty k v Empty;

rm_iterateoi ::
  forall a b c. Rbta a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iterateoi Empty c f sigma = sigma;
rm_iterateoi (Branch col l k v r) c f sigma =
  (if c sigma
    then let {
           sigmaa = rm_iterateoi l c f sigma;
         } in (if c sigmaa then rm_iterateoi r c f (f (k, v) sigmaa)
                else sigmaa)
    else sigma);

map_prod :: forall a b c d. (a -> b) -> (c -> d) -> (a, c) -> (b, d);
map_prod f g (a, b) = (f a, g b);

zip_fill :: forall a b. [a] -> [b] -> [(Maybe a, Maybe b)];
zip_fill (x : xs) (y : ys) = (Just x, Just y) : zip_fill xs ys;
zip_fill [] ys = map (\ y -> (Nothing, Just y)) ys;
zip_fill xs [] = map (\ x -> (Just x, Nothing)) xs;

list_all_rec :: forall a. (a -> Bool) -> [a] -> Bool;
list_all_rec p [] = True;
list_all_rec p (a : l) = p a && list_all_rec p l;

swap :: forall a b. (a, b) -> (b, a);
swap p = (snd p, fst p);

while :: forall a. (a -> Bool) -> (a -> a) -> a -> a;
while b c s = (if b s then while b c (c s) else s);

inl_rule :: forall a b c. a -> Nat -> Ta_rule (Sum (Term b ()) c) a;
inl_rule = (\ f n -> TA_rule f (replicate n (Inl (Var ()))) (Inl (Var ())));

inr_rule :: forall a b c. a -> Nat -> Ta_rule (Sum b (Term c ())) a;
inr_rule = (\ f n -> TA_rule f (replicate n (Inr (Var ()))) (Inr (Var ())));

compare_height ::
  forall a b. Rbta a b -> Rbta a b -> Rbta a b -> Rbta a b -> Comparea;
compare_height sx s t tx =
  (case (skip_red sx, (skip_red s, (skip_red t, skip_red tx))) of {
    (Empty, (Empty, (_, Empty))) -> EQ;
    (Empty, (Empty, (_, Branch _ _ _ _ _))) -> LT;
    (Empty, (Branch _ _ _ _ _, (Empty, _))) -> EQ;
    (Empty, (Branch _ _ _ _ _, (Branch _ _ _ _ _, Empty))) -> EQ;
    (Empty, (Branch _ sa _ _ _, (Branch _ ta _ _ _, Branch _ txa _ _ _))) ->
      compare_height Empty sa ta (skip_black txa);
    (Branch _ _ _ _ _, (Empty, (Empty, Empty))) -> GT;
    (Branch _ _ _ _ _, (Empty, (Empty, Branch _ _ _ _ _))) -> LT;
    (Branch _ _ _ _ _, (Empty, (Branch _ _ _ _ _, Empty))) -> EQ;
    (Branch _ _ _ _ _, (Empty, (Branch _ _ _ _ _, Branch _ _ _ _ _))) -> LT;
    (Branch _ _ _ _ _, (Branch _ _ _ _ _, (Empty, _))) -> GT;
    (Branch _ sxa _ _ _, (Branch _ sa _ _ _, (Branch _ ta _ _ _, Empty))) ->
      compare_height (skip_black sxa) sa ta Empty;
    (Branch _ sxa _ _ _,
      (Branch _ sa _ _ _, (Branch _ ta _ _ _, Branch _ txa _ _ _)))
      -> compare_height (skip_black sxa) sa ta (skip_black txa);
  });

rbt_insert_with_key ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_key less f k v t = paint B (rbt_ins less f k v t);

rbt_insert :: forall a b. (a -> a -> Bool) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert less = rbt_insert_with_key less (\ _ _ nv -> nv);

rbt_lookup :: forall a b. (a -> a -> Bool) -> Rbta a b -> a -> Maybe b;
rbt_lookup less (Branch uu l x y r) k =
  (if less k x then rbt_lookup less l k
    else (if less x k then rbt_lookup less r k else Just y));
rbt_lookup less Empty k = Nothing;

the_res :: forall a. Dres a -> a;
the_res (DRETURN x) = x;

tal_eps :: forall a b. Ta_list a b -> [(a, a)];
tal_eps (Ta_list x1 x2 x3) = x3;

map2set_memb :: forall a b c. (a -> b -> Maybe c) -> a -> b -> Bool;
map2set_memb l k s = (case l k s of {
                       Nothing -> False;
                       Just _ -> True;
                     });

adapt_vars :: forall a b c. Term a b -> Term a c;
adapt_vars (Fun f ts) = Fun f (map adapt_vars ts);

part :: forall a b. (Linorder b) => (a -> b) -> b -> [a] -> ([a], ([a], [a]));
part f pivot (x : xs) =
  (case part f pivot xs of {
    (lts, (eqs, gts)) ->
      let {
        xa = f x;
      } in (if less xa pivot then (x : lts, (eqs, gts))
             else (if less pivot xa then (lts, (eqs, x : gts))
                    else (lts, (x : eqs, gts))));
  });
part f pivot [] = ([], ([], []));

sort_key :: forall a b. (Linorder b) => (a -> b) -> [a] -> [a];
sort_key f xs =
  (case xs of {
    [] -> [];
    [_] -> xs;
    [x, y] -> (if less_eq (f x) (f y) then xs else [y, x]);
    _ : _ : _ : _ ->
      (case part f
              (f (nth xs
                   (divide_nat (size_list xs) (nat_of_integer (2 :: Integer)))))
              xs
        of {
        (lts, (eqs, gts)) -> sort_key f lts ++ eqs ++ sort_key f gts;
      });
  });

remdups_sort :: forall a. (Eq a, Linorder a) => [a] -> [a];
remdups_sort xs = remdups_adj (sort_key (\ x -> x) xs);

rbt_bulkload :: forall a b. (a -> a -> Bool) -> [(a, b)] -> Rbta a b;
rbt_bulkload less xs = foldr (\ (a, b) -> rbt_insert less a b) xs Empty;

tal_final :: forall a b. Ta_list a b -> [a];
tal_final (Ta_list x1 x2 x3) = x1;

tal_rules :: forall a b. Ta_list a b -> [Ta_rule a b];
tal_rules (Ta_list x1 x2 x3) = x2;

map2set_insert :: forall a b c. (a -> () -> b -> c) -> a -> b -> c;
map2set_insert i k s = i k () s;

glist_member :: forall a. (a -> a -> Bool) -> a -> [a] -> Bool;
glist_member eq x [] = False;
glist_member eq x (y : ys) = eq x y || glist_member eq x ys;

glist_insert :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
glist_insert eq x xs = (if glist_member eq x xs then xs else x : xs);

it_to_list ::
  forall a b c d e.
    (a -> (b -> Bool) -> (c -> [c] -> [c]) -> [d] -> e) -> a -> e;
it_to_list it s = it s (\ _ -> True) (\ x l -> l ++ [x]) [];

is_Nil :: forall a. [a] -> Bool;
is_Nil a = (case a of {
             [] -> True;
             _ : _ -> False;
           });

sum_eq ::
  forall a b c d.
    (a -> b -> Bool) -> (c -> d -> Bool) -> Sum a c -> Sum b d -> Bool;
sum_eq eql eqr s1 s2 = (case (s1, s2) of {
                         (Inl x1, Inl a) -> eql x1 a;
                         (Inl _, Inr _) -> False;
                         (Inr _, Inl _) -> False;
                         (Inr x1, Inr a) -> eqr x1 a;
                       });

tRS_terms_impl :: forall a b. [(Term a b, Term a b)] -> [Term a b];
tRS_terms_impl r = concatMap (\ (l, ra) -> [l, ra]) r;

ins_rm_basic_ops :: forall a. (Compare_order a) => a -> Rbt a () -> Rbt a ();
ins_rm_basic_ops x s = insert x () s;

r_rhs :: forall a b. Ta_rule a b -> a;
r_rhs (TA_rule x1 x2 x3) = x3;

is_None :: forall a. Maybe a -> Bool;
is_None a = (case a of {
              Nothing -> True;
              Just _ -> False;
            });

list_eq :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
list_eq eq [] [] = True;
list_eq eq (aa : la) (a : l) = (if eq aa a then list_eq eq la l else False);
list_eq uu (v : va) [] = False;
list_eq uu [] (v : va) = False;

prod_eq ::
  forall a b c d.
    (a -> b -> Bool) -> (c -> d -> Bool) -> (a, c) -> (b, d) -> Bool;
prod_eq eqa eqb x1 x2 = (case x1 of {
                          (a1, b1) -> (case x2 of {
(a2, b2) -> eqa a1 a2 && eqb b1 b2;
                                      });
                        });

right_ground_trs :: forall a b. Set (Term a b, Term a b) -> Bool;
right_ground_trs r = ball r (\ (_, a) -> ground a);

map_ta_rule ::
  forall a b c d. (a -> b) -> (c -> d) -> Ta_rule a c -> Ta_rule b d;
map_ta_rule f1 f2 (TA_rule x1 x2 x3) = TA_rule (f2 x1) (map f1 x2) (f1 x3);

map_ta_list ::
  forall a b c d. (a -> b) -> (c -> d) -> Ta_list a c -> Ta_list b d;
map_ta_list f1 f2 (Ta_list x1 x2 x3) =
  Ta_list (map f1 x1) (map (map_ta_rule f1 f2) x2) (map (map_prod f1 f1) x3);

rbt_comp_ins ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_ins c f k v Empty = Branch R Empty k v Empty;
rbt_comp_ins c f k v (Branch B l x y r) =
  (case c k x of {
    Eqa -> Branch B l x (f k y v) r;
    Lt -> balance (rbt_comp_ins c f k v l) x y r;
    Gt -> balance l x y (rbt_comp_ins c f k v r);
  });
rbt_comp_ins c f k v (Branch R l x y r) =
  (case c k x of {
    Eqa -> Branch R l x (f k y v) r;
    Lt -> Branch R (rbt_comp_ins c f k v l) x y r;
    Gt -> Branch R l x y (rbt_comp_ins c f k v r);
  });

rbt_comp_insert_with_key ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_insert_with_key c f k v t = paint B (rbt_comp_ins c f k v t);

comp_sunion_with ::
  forall a b.
    (a -> a -> Ordera) ->
      (a -> b -> b -> b) -> [(a, b)] -> [(a, b)] -> [(a, b)];
comp_sunion_with c f ((ka, va) : asa) ((k, v) : bs) =
  (case c k ka of {
    Eqa -> (ka, f ka va v) : comp_sunion_with c f asa bs;
    Lt -> (k, v) : comp_sunion_with c f ((ka, va) : asa) bs;
    Gt -> (ka, va) : comp_sunion_with c f asa ((k, v) : bs);
  });
comp_sunion_with c f [] bs = bs;
comp_sunion_with c f asa [] = asa;

rbt_comp_union_with_key ::
  forall a b.
    (a -> a -> Ordera) ->
      (a -> b -> b -> b) -> Rbta a b -> Rbta a b -> Rbta a b;
rbt_comp_union_with_key c f t1 t2 =
  (case compare_height t1 t1 t2 t2 of {
    LT -> folda (rbt_comp_insert_with_key c (\ k v w -> f k w v)) t1 t2;
    GT -> folda (rbt_comp_insert_with_key c f) t2 t1;
    EQ -> rbtreeify (comp_sunion_with c f (entries t1) (entries t2));
  });

set_iterator_image ::
  forall a b c.
    (a -> b) ->
      ((c -> Bool) -> (a -> c -> c) -> c -> c) ->
        (c -> Bool) -> (b -> c -> c) -> c -> c;
set_iterator_image g it = (\ c f -> it c (\ x -> f (g x)));

map_iterator_dom ::
  forall a b c.
    ((a -> Bool) -> ((b, c) -> a -> a) -> a -> a) ->
      (a -> Bool) -> (b -> a -> a) -> a -> a;
map_iterator_dom it = set_iterator_image fst it;

union_image_rs_code ::
  forall a b.
    (Compare a, Compare b) => Rbta a () -> (a -> Rbta b ()) -> Rbta b ();
union_image_rs_code s f =
  (map_iterator_dom . rm_iterateoi) s (\ _ -> True)
    (\ x -> rbt_comp_union_with_key compare (\ _ _ rv -> rv) (f x)) Empty;

ta_rules_impl ::
  forall a b c d e f g h. (a, (b, (c, (d, (e, (f, (g, h))))))) -> b;
ta_rules_impl (f, (r, (e, (rhs, (idx, (det, (efcl, eicl))))))) = r;

ta_final_impl ::
  forall a b c d e f g h. (a, (b, (c, (d, (e, (f, (g, h))))))) -> a;
ta_final_impl (f, (r, (e, (rhs, (idx, (det, (efcl, eicl))))))) = f;

ta_eps_impl ::
  forall a b c d e f g h. (a, (b, (c, (d, (e, (f, (g, h))))))) -> c;
ta_eps_impl (f, (r, (e, (rhs, (idx, (det, (efcl, eicl))))))) = e;

comp_res_of_order :: Ordera -> Comp_res;
comp_res_of_order Eqa = EQUAL;
comp_res_of_order Lt = LESS;
comp_res_of_order Gt = GREATER;

compare_res :: forall a. (Compare a) => a -> a -> Comp_res;
compare_res x y = comp_res_of_order (compare x y);

rbt_comp_insert ::
  forall a b. (a -> a -> Ordera) -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_insert c = rbt_comp_insert_with_key c (\ _ _ nv -> nv);

r_lhs_states :: forall a b. Ta_rule a b -> [a];
r_lhs_states (TA_rule x1 x2 x3) = x2;

rbt_bulkloada :: forall a b. (Compare_order a) => [(a, b)] -> Rbta a b;
rbt_bulkloada xs = foldr (\ (a, b) -> rbt_inserta a b) xs Empty;

option_eq :: forall a b. (a -> b -> Bool) -> Maybe a -> Maybe b -> Bool;
option_eq eq v1 v2 = (case (v1, v2) of {
                       (Nothing, Nothing) -> True;
                       (Nothing, Just _) -> False;
                       (Just _, Nothing) -> False;
                       (Just x1, Just a) -> eq x1 a;
                     });

gTT_to_RR2_impl ::
  forall a b.
    (Compare_order a,
      Compare_order b) => Rbta (a, Nat) () ->
                            ((Rbta b (),
                               (Rbta (Ta_rule b a) (),
                                 ([(b, b)],
                                   (Rbta b (),
                                     (Rbta (a, Nat) (Rbta ([b], b) ()),
                                       (Bool,
 (b -> Rbta b (), b -> Rbta b ()))))))),
                              (Rbta b (),
                                (Rbta (Ta_rule b a) (),
                                  ([(b, b)],
                                    (Rbta b (),
                                      (Rbta (a, Nat) (Rbta ([b], b) ()),
(Bool, (b -> Rbta b (), b -> Rbta b ())))))))) ->
                              (Rbta (Maybe (Maybe b, Maybe b)) (),
                                (Rbta (Ta_rule (Maybe (Maybe b, Maybe b))
(Maybe a, Maybe a))
                                   (),
                                  [(Maybe (Maybe b, Maybe b),
                                     Maybe (Maybe b, Maybe b))]));
gTT_to_RR2_impl =
  (\ x xa ->
    (rbt_comp_insert compare_option Nothing () Empty,
      (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
         (gen_image
           (\ xb ->
             foldli
               (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                 xb))
           Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
           (map_ta_rule Just id)
           (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
             (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
               (gen_image
                 (\ xb ->
                   foldli
                     (it_to_list
                       (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                       xb))
                 Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
                 (\ (TA_rule xb xc xd) ->
                   TA_rule (Just xb, Nothing)
                     (map (\ xe -> (Just xe, Nothing)) xc) (Just xd, Nothing))
                 (ta_rules_impl (fst xa)))
               (gen_image
                 (\ xb ->
                   foldli
                     (it_to_list
                       (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                       xb))
                 Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
                 (\ (TA_rule xb xc xd) ->
                   TA_rule (Nothing, Just xb)
                     (map (\ xe -> (Nothing, Just xe)) xc) (Nothing, Just xd))
                 (ta_rules_impl (snd xa))))
             (gen_image (\ xb -> foldli (id xb)) Empty
               (\ k -> rbt_comp_insert compare_ta_rule k ())
               (\ (xb, a) ->
                 (case a of {
                   TA_rule aa b c ->
                     (case xb of {
                       TA_rule xc xd xe ->
                         (\ xf xg xh ->
                           TA_rule (Just xc, Just xf) (zip_fill xd xg)
                             (Just xe, Just xh));
                     })
                       aa
                       b
                       c;
                 }))
               (gen_Sigma
                 (\ xb ->
                   foldli
                     (it_to_list
                       (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                       xb))
                 (\ xb ->
                   foldli
                     (it_to_list
                       (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                       xb))
                 [] (glist_insert
                      (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                 (ta_rules_impl (fst xa)) (\ _ -> ta_rules_impl (snd xa))))))
         (gen_image
           (\ xb ->
             foldli
               (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                 xb))
           Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
           (\ (xb, xc) ->
             TA_rule (Just xb, Just xb) (replicate xc Nothing) Nothing)
           x),
        gen_union (\ xb -> foldli (id xb))
          (glist_insert
            (prod_eq
              (option_eq
                (prod_eq (option_eq (comp2eq compare_res))
                  (option_eq (comp2eq compare_res))))
              (option_eq
                (prod_eq (option_eq (comp2eq compare_res))
                  (option_eq (comp2eq compare_res))))))
          (gen_image (\ xb -> foldli (id xb)) []
            (glist_insert
              (prod_eq
                (option_eq
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res))))
                (option_eq
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res))))))
            (\ (xb, xc) -> (Just xb, Just xc))
            (gen_union (\ xb -> foldli (id xb))
              (glist_insert
                (prod_eq
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res)))
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res)))))
              (gen_image (\ xb -> foldli (id xb)) []
                (glist_insert
                  (prod_eq
                    (prod_eq (option_eq (comp2eq compare_res))
                      (option_eq (comp2eq compare_res)))
                    (prod_eq (option_eq (comp2eq compare_res))
                      (option_eq (comp2eq compare_res)))))
                (\ (a, b) ->
                  (case a of {
                    (xb, xc) -> (\ xd -> ((Just xb, xd), (Just xc, xd)));
                  })
                    b)
                (concatMap
                  (\ xb ->
                    map (\ a -> (xb, a))
                      (gen_union (\ xc -> foldli (id xc))
                        (glist_insert (option_eq (comp2eq compare_res)))
                        [Nothing]
                        (gen_image
                          (\ xc ->
                            foldli
                              (it_to_list
                                (map_iterator_dom .
                                  foldli . it_to_list rm_iterateoi)
                                xc))
                          [] (glist_insert (option_eq (comp2eq compare_res)))
                          Just
                          (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                            (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                              (union_image_rs_code (ta_rules_impl (snd xa))
                                (\ xaa ->
                                  rbt_comp_insert compare (r_rhs xaa) ()
                                    (gen_set Empty
                                      (\ k -> rbt_comp_insert compare k ())
                                      (r_lhs_states xaa))))
                              (union_image_rs_code
                                (case snd xa of {
                                  (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                                    rbt_bulkloada (map (\ k -> (k, ())) e);
                                })
                                (\ (xaa, xba) ->
                                  rbt_comp_insert compare xaa ()
                                    (rbt_comp_insert compare xba () Empty))))
                            (ta_final_impl (snd xa))))))
                  (ta_eps_impl (fst xa))))
              (gen_image (\ xb -> foldli (id xb)) []
                (glist_insert
                  (prod_eq
                    (prod_eq (option_eq (comp2eq compare_res))
                      (option_eq (comp2eq compare_res)))
                    (prod_eq (option_eq (comp2eq compare_res))
                      (option_eq (comp2eq compare_res)))))
                (\ (xb, (xc, xd)) -> ((xb, Just xc), (xb, Just xd)))
                (concatMap (\ xb -> map (\ a -> (xb, a)) (ta_eps_impl (snd xa)))
                  (gen_union (\ xb -> foldli (id xb))
                    (glist_insert (option_eq (comp2eq compare_res))) [Nothing]
                    (gen_image
                      (\ xb ->
                        foldli
                          (it_to_list
                            (map_iterator_dom .
                              foldli . it_to_list rm_iterateoi)
                            xb))
                      [] (glist_insert (option_eq (comp2eq compare_res))) Just
                      (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                        (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                          (union_image_rs_code (ta_rules_impl (fst xa))
                            (\ xaa ->
                              rbt_comp_insert compare (r_rhs xaa) ()
                                (gen_set Empty
                                  (\ k -> rbt_comp_insert compare k ())
                                  (r_lhs_states xaa))))
                          (union_image_rs_code
                            (case fst xa of {
                              (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                                rbt_bulkloada (map (\ k -> (k, ())) e);
                            })
                            (\ (xaa, xb) ->
                              rbt_comp_insert compare xaa ()
                                (rbt_comp_insert compare xb () Empty))))
                        (ta_final_impl (fst xa)))))))))
          (gen_image
            (\ xb ->
              foldli
                (it_to_list
                  (map_iterator_dom . foldli . it_to_list rm_iterateoi) xb))
            [] (glist_insert
                 (prod_eq
                   (option_eq
                     (prod_eq (option_eq (comp2eq compare_res))
                       (option_eq (comp2eq compare_res))))
                   (option_eq
                     (prod_eq (option_eq (comp2eq compare_res))
                       (option_eq (comp2eq compare_res))))))
            (\ xb -> (Just (Just xb, Just xb), Nothing))
            (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
              (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                  (union_image_rs_code (ta_rules_impl (fst xa))
                    (\ xaa ->
                      rbt_comp_insert compare (r_rhs xaa) ()
                        (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                          (r_lhs_states xaa))))
                  (union_image_rs_code
                    (case fst xa of {
                      (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                        rbt_bulkloada (map (\ k -> (k, ())) e);
                    })
                    (\ (xaa, xb) ->
                      rbt_comp_insert compare xaa ()
                        (rbt_comp_insert compare xb () Empty))))
                (ta_final_impl (fst xa)))
              (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                  (union_image_rs_code (ta_rules_impl (snd xa))
                    (\ xaa ->
                      rbt_comp_insert compare (r_rhs xaa) ()
                        (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                          (r_lhs_states xaa))))
                  (union_image_rs_code
                    (case snd xa of {
                      (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                        rbt_bulkloada (map (\ k -> (k, ())) e);
                    })
                    (\ (xaa, xb) ->
                      rbt_comp_insert compare xaa ()
                        (rbt_comp_insert compare xb () Empty))))
                (ta_final_impl (snd xa))))))));

cmn_ta_rules1_impl :: forall a b. Term a b -> [Ta_rule (Maybe (Term a b)) a];
cmn_ta_rules1_impl (Fun f ts) =
  TA_rule f (map Just ts) (Just (Fun f ts)) : concatMap cmn_ta_rules1_impl ts;
cmn_ta_rules1_impl (Var x) = [];

cmn_ta_rules_impl :: forall a b. [Term a b] -> [Ta_rule (Maybe (Term a b)) a];
cmn_ta_rules_impl ts = concatMap cmn_ta_rules1_impl ts;

trs_to_ta_B_impl ::
  forall a b. [(Term a b, Term a b)] -> Ta_list (Maybe (Term a b)) a;
trs_to_ta_B_impl r =
  Ta_list [] (cmn_ta_rules_impl (tRS_terms_impl r))
    (map (map_prod Just Just . swap) r);

trs_to_ta_A_impl ::
  forall a b. [(Term a b, Term a b)] -> Ta_list (Maybe (Term a b)) a;
trs_to_ta_A_impl r =
  Ta_list [] (cmn_ta_rules_impl (tRS_terms_impl r))
    (map (map_prod Just Just) r);

trs_to_gtt_impl ::
  forall a b.
    [(Term a b, Term a b)] ->
      (Ta_list (Maybe (Term a b)) a, Ta_list (Maybe (Term a b)) a);
trs_to_gtt_impl r = (trs_to_ta_A_impl r, trs_to_ta_B_impl r);

term_TA_list :: forall a b c. (Term a b -> c) -> Term a b -> [Ta_rule c a];
term_TA_list h (Fun f ts) =
  TA_rule f (map h ts) (h (Fun f ts)) : concatMap (term_TA_list h) ts;
term_TA_list h (Var x) = [];

term_TA_impl ::
  forall a b c.
    (Compare_order a,
      Compare_order c) => (Term a b -> c) -> Term a b -> Rbta (Ta_rule c a) ();
term_TA_impl h t = rbt_bulkloada (map (\ k -> (k, ())) (term_TA_list h t));

memb_rm_basic_ops :: forall a. (Compare_order a) => a -> Rbt a () -> Bool;
memb_rm_basic_ops x s = not (is_none (lookup s x));

rbt_comp_lookup :: forall a b. (a -> a -> Ordera) -> Rbta a b -> a -> Maybe b;
rbt_comp_lookup c Empty k = Nothing;
rbt_comp_lookup c (Branch uu l x y r) k = (case c k x of {
    Eqa -> Just y;
    Lt -> rbt_comp_lookup c l k;
    Gt -> rbt_comp_lookup c r k;
  });

ta_idx_rhs_init_code ::
  forall a b c.
    (Compare a, Compare b,
      Compare c) => Bool ->
                      Rbta (Ta_rule a b) () ->
                        (a -> Rbta c ()) ->
                          (Rbta (b, Nat) (Rbta ([a], a) ()), (Bool, Rbta c ()));
ta_idx_rhs_init_code det rs efcl =
  (map_iterator_dom . rm_iterateoi) rs (\ _ -> True)
    (\ x (a, (aa, ba)) ->
      (case x of {
        TA_rule xg xh xi ->
          let {
            y = size_list xh;
          } in (case rbt_comp_lookup compare_prod a (xg, y) of {
                 Nothing ->
                   (rbt_comp_insert compare_prod (xg, y)
                      (rbt_comp_insert compare_prod (xh, xi) () Empty) a,
                     (aa, rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                            (efcl xi) ba));
                 Just xj ->
                   (rbt_comp_insert compare_prod (xg, y)
                      (rbt_comp_insert compare_prod (xh, xi) () xj) a,
                     ((if aa
                        then gen_ball (map_iterator_dom . rm_iterateoi) xj
                               (\ (xk, _) ->
                                 not (list_eq (comp2eq compare_res) xh xk))
                        else False),
                       rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                         (efcl xi) ba));
               });
      }))
    (Empty, (det, Empty));

g_from_list_aux_dflt_basic_oops_rm_basic_ops ::
  forall a. (Compare_order a) => Rbt a () -> [a] -> Rbt a ();
g_from_list_aux_dflt_basic_oops_rm_basic_ops accs (x : l) =
  g_from_list_aux_dflt_basic_oops_rm_basic_ops (ins_rm_basic_ops x accs) l;
g_from_list_aux_dflt_basic_oops_rm_basic_ops y [] = y;

empty_rm_basic_ops :: forall a. (Linorder a) => () -> Rbt a ();
empty_rm_basic_ops = (\ _ -> empty);

g_from_list_dflt_basic_oops_rm_basic_ops ::
  forall a. (Compare_order a) => [a] -> Rbt a ();
g_from_list_dflt_basic_oops_rm_basic_ops l =
  g_from_list_aux_dflt_basic_oops_rm_basic_ops (empty_rm_basic_ops ()) l;

iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops ::
  forall a b.
    (Linorder a) => Rbt a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops s =
  (\ c f -> rm_iterateoi (impl_of s) c (f . fst));

g_to_list_dflt_basic_oops_rm_basic_ops ::
  forall a. (Linorder a) => Rbt a () -> [a];
g_to_list_dflt_basic_oops_rm_basic_ops s =
  iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops s (\ _ -> True)
    (\ a b -> a : b) [];

g_union_dflt_basic_oops_rm_basic_ops ::
  forall a. (Compare_order a) => Rbt a () -> Rbt a () -> Rbt a ();
g_union_dflt_basic_oops_rm_basic_ops s1 s2 =
  iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops s1 (\ _ -> True)
    ins_rm_basic_ops s2;

elem_list_to_rm ::
  forall a b. (Compare_order b) => (a -> b) -> [a] -> Rbt b [a];
elem_list_to_rm key (d : ds) = let {
                                 rm = elem_list_to_rm key ds;
                                 k = key d;
                               } in (case lookup rm k of {
                                      Nothing -> insert k [d] rm;
                                      Just dataa -> insert k (d : dataa) rm;
                                    });
elem_list_to_rm key [] = empty;

relpow_impl ::
  forall a b.
    ([a] -> [a]) -> ([a] -> b -> b) -> (a -> b -> Bool) -> [a] -> b -> Nat -> b;
relpow_impl succ un memb new have m =
  (if equal_nat m zero_nat then un new have
    else (if null new then have
           else let {
                  maybe = succ new;
                  havea = un new have;
                  newa = filter (\ n -> not (memb n havea)) maybe;
                } in relpow_impl succ un memb newa havea
                       (minus_nat m one_nat)));

rtrancl_impl ::
  forall a b.
    ([(a, a)] -> [a] -> [a]) ->
      ([a] -> b -> b) -> (a -> b -> Bool) -> b -> [(a, a)] -> [a] -> b;
rtrancl_impl gen_succ un memb emp rel =
  let {
    succ = gen_succ rel;
    n = size_list rel;
  } in (\ asa -> relpow_impl succ un memb asa emp n);

rm_set_lookup :: forall a b. (Compare_order a) => Rbt a [b] -> a -> [b];
rm_set_lookup rm = (\ a -> (case lookup rm a of {
                             Nothing -> [];
                             Just rules -> rules;
                           }));

rs_Union :: forall a. (Compare_order a) => [Rbt a ()] -> Rbt a ();
rs_Union = foldl g_union_dflt_basic_oops_rm_basic_ops (empty_rm_basic_ops ());

rtrancl_rbt_impl :: forall a. (Compare_order a) => [(a, a)] -> [a] -> Rbt a ();
rtrancl_rbt_impl =
  rtrancl_impl
    (\ r ->
      let {
        rm = elem_list_to_rm fst r;
      } in (\ asa ->
             g_to_list_dflt_basic_oops_rm_basic_ops
               (rs_Union
                 (map (\ a ->
                        g_from_list_dflt_basic_oops_rm_basic_ops
                          (map snd (rm_set_lookup rm a)))
                   asa))))
    (\ asa bs ->
      g_union_dflt_basic_oops_rm_basic_ops bs
        (g_from_list_dflt_basic_oops_rm_basic_ops asa))
    memb_rm_basic_ops (empty_rm_basic_ops ());

g_list_to_map_rm_basic_ops ::
  forall a b. (Compare_order a) => [(a, b)] -> Rbt a b;
g_list_to_map_rm_basic_ops l =
  foldl (\ m (k, v) -> insert k v m) empty (reverse l);

memo_rbt_rtrancl :: forall a. (Compare_order a) => [(a, a)] -> a -> Rbt a ();
memo_rbt_rtrancl r =
  let {
    tr = rtrancl_rbt_impl r;
    rm = g_list_to_map_rm_basic_ops
           (map (\ a -> (a, tr [a]))
             (((g_to_list_dflt_basic_oops_rm_basic_ops .
                 g_from_list_dflt_basic_oops_rm_basic_ops) .
                map fst)
               r));
  } in (\ a -> (case lookup rm a of {
                 Nothing -> g_from_list_dflt_basic_oops_rm_basic_ops [a];
                 Just asa -> asa;
               }));

ta_make_code ::
  forall a b c.
    (Compare a, Compare_order b,
      Compare c) => Rbta a () ->
                      Rbta (Ta_rule b c) () ->
                        [(b, b)] ->
                          (Rbta a (),
                            (Rbta (Ta_rule b c) (),
                              ([(b, b)],
                                (Rbta b (),
                                  (Rbta (c, Nat) (Rbta ([b], b) ()),
                                    (Bool,
                                      (b -> Rbta b (), b -> Rbta b ())))))));
ta_make_code f r e =
  let {
    a = ta_idx_rhs_init_code (is_Nil e) r
          (\ xi -> impl_of (memo_rbt_rtrancl e xi));
  } in (case a of {
         (ab, (aa, ba)) ->
           (f, (r, (e, (ba, (ab, (aa, ((\ s -> impl_of (memo_rbt_rtrancl e s)),
(\ s ->
  impl_of
    (memo_rbt_rtrancl
      (gen_image foldli []
        (glist_insert (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
        (\ xc -> (snd xc, fst xc)) e)
      s)))))))));
       });

rbt_comp_bulkload :: forall a b. (a -> a -> Ordera) -> [(a, b)] -> Rbta a b;
rbt_comp_bulkload c xs = foldr (\ (a, b) -> rbt_comp_insert c a b) xs Empty;

ta_nat_impl ::
  forall a b.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            (Rbta Nat (),
                              (Rbta (Ta_rule Nat b) (),
                                ([(Nat, Nat)],
                                  (Rbta Nat (),
                                    (Rbta (b, Nat) (Rbta ([Nat], Nat) ()),
                                      (Bool,
(Nat -> Rbta Nat (), Nat -> Rbta Nat ())))))));
ta_nat_impl a =
  let {
    x = it_to_list (map_iterator_dom . rm_iterateoi)
          (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
            (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
              (union_image_rs_code (ta_rules_impl a)
                (\ xa ->
                  rbt_comp_insert compare (r_rhs xa) ()
                    (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                      (r_lhs_states xa))))
              (union_image_rs_code
                (case a of {
                  (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                    rbt_bulkloada (map (\ k -> (k, ())) e);
                })
                (\ (xa, xb) ->
                  rbt_comp_insert compare xa ()
                    (rbt_comp_insert compare xb () Empty))))
            (ta_final_impl a));
    y = rbt_comp_bulkload compare (zip x (upt zero_nat (size_list x)));
    y_a = (\ (TA_rule xa xb xc) ->
            TA_rule xa (map (\ xd -> the (rbt_comp_lookup compare y xd)) xb)
              (the (rbt_comp_lookup compare y xc)));
  } in ta_make_code
         (gen_image (map_iterator_dom . rm_iterateoi) Empty
           (\ k -> rbt_comp_insert compare_nat k ())
           (\ xa -> the (rbt_comp_lookup compare y xa)) (ta_final_impl a))
         (gen_image (map_iterator_dom . rm_iterateoi) Empty
           (\ k -> rbt_comp_insert compare_ta_rule k ()) y_a (ta_rules_impl a))
         (gen_image foldli [] (glist_insert (prod_eq equal_nat equal_nat))
           (\ (xa, xb) ->
             (the (rbt_comp_lookup compare y xa),
               the (rbt_comp_lookup compare y xb)))
           (ta_eps_impl a));

r_root :: forall a b. Ta_rule a b -> b;
r_root (TA_rule x1 x2 x3) = x1;

delta_epsilon_infer0_rbt ::
  forall a b c d e f g h i j k l m n o p q r s.
    (Eq c) => (a, (Rbta (Ta_rule b c) d, (e, (f, (g, (h, (i, j))))))) ->
                (k, (Rbta (Ta_rule l c) m, (n, (o, (p, (q, (r, s))))))) ->
                  [(b, l)];
delta_epsilon_infer0_rbt a b =
  map_filter
    (\ x ->
      (if (case x of {
            (ra, rb) ->
              (case (ra, rb) of {
                (TA_rule f ps _, TA_rule g qs _) ->
                  f == g && null ps && null qs;
              });
          })
        then Just (map_prod r_rhs r_rhs x) else Nothing))
    (product (keys (ta_rules_impl a)) (keys (ta_rules_impl b)));

delta_epsilon_infer1_rbt ::
  forall a b c d e f g h i j k l m n o p q r.
    (Eq b, Eq c,
      Eq k) => (a, (Rbta (Ta_rule b c) d, ([(b, b)], (e, (f, (g, (h, i))))))) ->
                 (j, (Rbta (Ta_rule k c) l,
                       ([(k, k)], (m, (n, (o, (p, q))))))) ->
                   (b, k) -> Rbta (b, k) r -> [(b, k)];
delta_epsilon_infer1_rbt a b pq x =
  map_filter
    (\ xa ->
      (if (case xa of {
            (ra, rb) ->
              (case (ra, rb) of {
                (TA_rule f ps _, TA_rule g qs _) ->
                  f == g &&
                    equal_nat (size_list ps) (size_list qs) &&
                      membera (zip ps qs) (fst pq, snd pq) &&
                        all (membera (pq : keys x)) (zip ps qs);
              });
          })
        then Just (map_prod r_rhs r_rhs xa) else Nothing))
    (product (keys (ta_rules_impl a)) (keys (ta_rules_impl b))) ++
    map_filter
      (\ xa ->
        (if (case xa of {
              (p, _) -> p == fst pq;
            })
          then Just (case xa of {
                      (_, p) -> (p, snd pq);
                    })
          else Nothing))
      (ta_eps_impl a) ++
      map_filter
        (\ xa ->
          (if (case xa of {
                (q, _) -> q == snd pq;
              })
            then Just (case xa of {
                        (_, aa) -> (fst pq, aa);
                      })
            else Nothing))
        (ta_eps_impl b);

delta_epsilon_rbt_0 ::
  forall a b.
    (Compare_order a, Eq a, Compare_order b,
      Eq b) => (Rbta a (),
                 (Rbta (Ta_rule a b) (),
                   ([(a, a)],
                     (Rbta a (),
                       (Rbta (b, Nat) (Rbta ([a], a) ()),
                         (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                 (Rbta a (),
                   (Rbta (Ta_rule a b) (),
                     ([(a, a)],
                       (Rbta a (),
                         (Rbta (b, Nat) (Rbta ([a], a) ()),
                           (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                   ((a, a), Rbta (a, a) ()) -> Dres (Rbta (a, a) ());
delta_epsilon_rbt_0 a b x =
  (case x of {
    (aa, ba) ->
      (if map2set_memb (\ k t -> rbt_lookupa t k) aa ba then DRETURN ba
        else foldl (\ s xa ->
                     dbind s (\ sa -> delta_epsilon_rbt_0 a b (xa, sa)))
               (DRETURN (map2set_insert rbt_inserta aa ba))
               (delta_epsilon_infer1_rbt a b aa ba));
  });

delta_epsilon_rbt ::
  forall a b.
    (Compare_order a, Eq a, Compare_order b,
      Eq b) => (Rbta a (),
                 (Rbta (Ta_rule a b) (),
                   ([(a, a)],
                     (Rbta a (),
                       (Rbta (b, Nat) (Rbta ([a], a) ()),
                         (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                 (Rbta a (),
                   (Rbta (Ta_rule a b) (),
                     ([(a, a)],
                       (Rbta a (),
                         (Rbta (b, Nat) (Rbta ([a], a) ()),
                           (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                   Dres (Rbta (a, a) ());
delta_epsilon_rbt a b =
  foldl (\ s x -> dbind s (\ sa -> delta_epsilon_rbt_0 a b (x, sa)))
    (DRETURN Empty) (delta_epsilon_infer0_rbt a b);

gTT_comp_rbt ::
  forall a b.
    (Compare_order a, Eq a, Compare_order b,
      Eq b) => ((Rbta a (),
                  (Rbta (Ta_rule a b) (),
                    ([(a, a)],
                      (Rbta a (),
                        (Rbta (b, Nat) (Rbta ([a], a) ()),
                          (Bool, (a -> Rbta a (), a -> Rbta a ()))))))),
                 (Rbta a (),
                   (Rbta (Ta_rule a b) (),
                     ([(a, a)],
                       (Rbta a (),
                         (Rbta (b, Nat) (Rbta ([a], a) ()),
                           (Bool, (a -> Rbta a (), a -> Rbta a ())))))))) ->
                 ((Rbta a (),
                    (Rbta (Ta_rule a b) (),
                      ([(a, a)],
                        (Rbta a (),
                          (Rbta (b, Nat) (Rbta ([a], a) ()),
                            (Bool, (a -> Rbta a (), a -> Rbta a ()))))))),
                   (Rbta a (),
                     (Rbta (Ta_rule a b) (),
                       ([(a, a)],
                         (Rbta a (),
                           (Rbta (b, Nat) (Rbta ([a], a) ()),
                             (Bool, (a -> Rbta a (), a -> Rbta a ())))))))) ->
                   Dres ((Rbta a (),
                           (Rbta (Ta_rule a b) (),
                             ([(a, a)],
                               (Rbta a (),
                                 (Rbta (b, Nat) (Rbta ([a], a) ()),
                                   (Bool,
                                     (a -> Rbta a (), a -> Rbta a ()))))))),
                          (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))));
gTT_comp_rbt g1 g2 =
  dbind (delta_epsilon_rbt (snd g1) (fst g2))
    (\ a ->
      dbind (delta_epsilon_rbt (fst g2) (snd g1))
        (\ a_a ->
          DRETURN
            (ta_make_code Empty
               (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
                 (ta_rules_impl (fst (fst g1, fst g2)))
                 (ta_rules_impl (snd (fst g1, fst g2))))
               (gen_union (\ x -> foldli (id x))
                 (glist_insert
                   (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                 (gen_union (\ x -> foldli (id x))
                   (glist_insert
                     (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                   (ta_eps_impl (fst g1)) (ta_eps_impl (fst g2)))
                 (keys a)),
              ta_make_code Empty
                (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
                  (ta_rules_impl (fst (snd g1, snd g2)))
                  (ta_rules_impl (snd (snd g1, snd g2))))
                (gen_union (\ x -> foldli (id x))
                  (glist_insert
                    (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                  (gen_union (\ x -> foldli (id x))
                    (glist_insert
                      (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                    (ta_eps_impl (snd g1)) (ta_eps_impl (snd g2)))
                  (keys a_a)))));

delta_epsilon_infer1_list ::
  forall a b.
    (Eq a,
      Eq b) => Ta_list a b -> Ta_list a b -> (a, a) -> [(a, a)] -> [(a, a)];
delta_epsilon_infer1_list a b pq bs =
  map_filter
    (\ x ->
      (if (case x of {
            (ra, rb) ->
              (case (ra, rb) of {
                (TA_rule f ps _, TA_rule g qs _) ->
                  f == g &&
                    equal_nat (size_list ps) (size_list qs) &&
                      membera (zip ps qs) (fst pq, snd pq) &&
                        all (membera ((fst pq, snd pq) : bs)) (zip ps qs);
              });
          })
        then Just (map_prod r_rhs r_rhs x) else Nothing))
    (product (tal_rules a) (tal_rules b)) ++
    map_filter
      (\ x ->
        (if (case x of {
              (p, _) -> p == fst pq;
            })
          then Just (case x of {
                      (_, p) -> (p, snd pq);
                    })
          else Nothing))
      (tal_eps a) ++
      map_filter
        (\ x ->
          (if (case x of {
                (q, _) -> q == snd pq;
              })
            then Just (case x of {
                        (_, aa) -> (fst pq, aa);
                      })
            else Nothing))
        (tal_eps b);

delta_epsilon_infer0_list ::
  forall a b c. (Eq b) => Ta_list a b -> Ta_list c b -> [(a, c)];
delta_epsilon_infer0_list a b =
  map_filter
    (\ x ->
      (if (case x of {
            (ra, rb) ->
              (case (ra, rb) of {
                (TA_rule f ps _, TA_rule g qs _) ->
                  f == g && null ps && null qs;
              });
          })
        then Just (map_prod r_rhs r_rhs x) else Nothing))
    (product (tal_rules a) (tal_rules b));

saturate_rec :: forall a. (Eq a) => (a -> [a] -> [a]) -> a -> [a] -> Maybe [a];
saturate_rec infer1_impl x bs =
  (if membera bs x then Just bs
    else fold (\ xa a -> (case a of {
                           Nothing -> Nothing;
                           Just aa -> saturate_rec infer1_impl xa aa;
                         }))
           (infer1_impl x bs) (Just (x : bs)));

saturate_impl :: forall a. (Eq a) => [a] -> (a -> [a] -> [a]) -> Maybe [a];
saturate_impl infer0_impl infer1_impl =
  fold (\ x a -> (case a of {
                   Nothing -> Nothing;
                   Just aa -> saturate_rec infer1_impl x aa;
                 }))
    infer0_impl (Just []);

delta_epsilon_impl ::
  forall a b. (Eq a, Eq b) => Ta_list a b -> Ta_list a b -> Maybe [(a, a)];
delta_epsilon_impl a b =
  saturate_impl (delta_epsilon_infer0_list a b) (delta_epsilon_infer1_list a b);

gTT_comp_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Ta_list a b, Ta_list a b) ->
                 (Ta_list a b, Ta_list a b) -> Maybe (Ta_list a b, Ta_list a b);
gTT_comp_impl g1 g2 =
  (case (delta_epsilon_impl (snd g1) (fst g2),
          delta_epsilon_impl (fst g2) (snd g1))
    of {
    (Nothing, _) -> Nothing;
    (Just _, Nothing) -> Nothing;
    (Just xs, Just ys) ->
      Just (Ta_list [] (tal_rules (fst g1) ++ tal_rules (fst g2))
              (tal_eps (fst g1) ++ tal_eps (fst g2) ++ xs),
             Ta_list [] (tal_rules (snd g1) ++ tal_rules (snd g2))
               (tal_eps (snd g1) ++ tal_eps (snd g2) ++ ys));
  });

delta_trancl_infer1 ::
  forall a b.
    (Eq a,
      Eq b) => Ta_list a b -> Ta_list a b -> (a, a) -> [(a, a)] -> [(a, a)];
delta_trancl_infer1 a b pq bs =
  delta_epsilon_infer1_list a b pq bs ++
    map_filter
      (\ x ->
        (if (case x of {
              (_, p) -> p == fst pq;
            })
          then Just (case x of {
                      (r, _) -> (r, snd pq);
                    })
          else Nothing))
      bs ++
      map_filter
        (\ x ->
          (if (case x of {
                (q, _) -> q == snd pq;
              })
            then Just (case x of {
                        (_, aa) -> (fst pq, aa);
                      })
            else Nothing))
        (pq : bs);

delta_trancl_infer0 ::
  forall a b c. (Eq b) => Ta_list a b -> Ta_list c b -> [(a, c)];
delta_trancl_infer0 a b = delta_epsilon_infer0_list a b;

delta_trancl_impl ::
  forall a b. (Eq a, Eq b) => Ta_list a b -> Ta_list a b -> Maybe [(a, a)];
delta_trancl_impl a b =
  saturate_impl (delta_trancl_infer0 a b) (delta_trancl_infer1 a b);

gTT_trancl_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Ta_list a b, Ta_list a b) -> Maybe (Ta_list a b, Ta_list a b);
gTT_trancl_impl g =
  (case (delta_trancl_impl (snd g) (fst g), delta_trancl_impl (fst g) (snd g))
    of {
    (Nothing, _) -> Nothing;
    (Just _, Nothing) -> Nothing;
    (Just xs, Just ys) ->
      Just (Ta_list [] (tal_rules (fst g)) (tal_eps (fst g) ++ xs),
             Ta_list [] (tal_rules (snd g)) (tal_eps (snd g) ++ ys));
  });

rtrancl_gtt ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 Maybe (Ta_list (Maybe (Term a b)) a,
                         Ta_list (Maybe (Term a b)) a);
rtrancl_gtt r = gTT_trancl_impl (trs_to_gtt_impl r);

left_gtt ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 Maybe (Ta_list (Sum (Maybe (Term a b)) (Maybe (Term a b))) a,
                         Ta_list (Sum (Maybe (Term a b)) (Maybe (Term a b))) a);
left_gtt r =
  bind (rtrancl_gtt r)
    (\ (a, b) ->
      gTT_comp_impl (map_ta_list Inl id b, map_ta_list Inl id a)
        (map_ta_list Inr id a, map_ta_list Inr id b));

tal_size :: forall a b. (Eq a, Eq b) => Ta_list a b -> (Nat, (Nat, Nat));
tal_size a =
  (size_list
     (uniq_list
       (concatMap (\ (TA_rule _ qs q) -> q : qs) (tal_rules a) ++
         concatMap (\ (l, r) -> [l, r]) (tal_eps a))),
    (size_list (uniq_list (tal_rules a)), size_list (uniq_list (tal_eps a))));

embed_term :: forall a b. Term a b -> Term a ();
embed_term t = map_term (\ x -> x) (const ()) t;

trs_to_ta_L_impl ::
  forall a b.
    (Compare_order a,
      Compare_order b) => Rbta (a, Nat) () ->
                            Rbta (Term a b, Term a b) () ->
                              (Rbta (Sum (Term a ()) (Term a ())) (),
                                (Rbta (Ta_rule (Sum (Term a ()) (Term a ())) a)
                                   (),
                                  ([(Sum (Term a ()) (Term a ()),
                                      Sum (Term a ()) (Term a ()))],
                                    (Rbta (Sum (Term a ()) (Term a ())) (),
                                      (Rbta (a, Nat)
 (Rbta ([Sum (Term a ()) (Term a ())], Sum (Term a ()) (Term a ())) ()),
(Bool,
  (Sum (Term a ()) (Term a ()) -> Rbta (Sum (Term a ()) (Term a ())) (),
    Sum (Term a ()) (Term a ()) -> Rbta (Sum (Term a ()) (Term a ())) ())))))));
trs_to_ta_L_impl =
  (\ x xa ->
    ta_make_code Empty
      (union_image_rs_code
        (gen_image
          (\ xb ->
            foldli
              (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                xb))
          Empty (\ k -> rbt_comp_insert compare_term k ()) fst xa)
        (\ xb ->
          rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
            (term_TA_impl Inl (embed_term xb))
            (gen_image
              (\ xc ->
                foldli
                  (it_to_list
                    (map_iterator_dom . foldli . it_to_list rm_iterateoi) xc))
              Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
              (\ (a, b) -> inl_rule a b) x)))
      (gen_image
        (\ xb ->
          foldli
            (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
              xb))
        [] (glist_insert
             (prod_eq (sum_eq (comp2eq compare_res) (comp2eq compare_res))
               (sum_eq (comp2eq compare_res) (comp2eq compare_res))))
        (\ (xb, xc) -> (Inl (embed_term xb), Inr (embed_term xc))) xa));

trs_to_ta_R_impl ::
  forall a b.
    (Compare_order a,
      Compare_order b) => Rbta (a, Nat) () ->
                            Rbta (Term a b, Term a b) () ->
                              (Rbta (Sum (Term a ()) (Term a ())) (),
                                (Rbta (Ta_rule (Sum (Term a ()) (Term a ())) a)
                                   (),
                                  ([(Sum (Term a ()) (Term a ()),
                                      Sum (Term a ()) (Term a ()))],
                                    (Rbta (Sum (Term a ()) (Term a ())) (),
                                      (Rbta (a, Nat)
 (Rbta ([Sum (Term a ()) (Term a ())], Sum (Term a ()) (Term a ())) ()),
(Bool,
  (Sum (Term a ()) (Term a ()) -> Rbta (Sum (Term a ()) (Term a ())) (),
    Sum (Term a ()) (Term a ()) -> Rbta (Sum (Term a ()) (Term a ())) ())))))));
trs_to_ta_R_impl =
  (\ x xa ->
    ta_make_code Empty
      (union_image_rs_code
        (gen_image
          (\ xb ->
            foldli
              (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                xb))
          Empty (\ k -> rbt_comp_insert compare_term k ()) snd xa)
        (\ xb ->
          rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
            (term_TA_impl Inr (embed_term xb))
            (gen_image
              (\ xc ->
                foldli
                  (it_to_list
                    (map_iterator_dom . foldli . it_to_list rm_iterateoi) xc))
              Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
              (\ (a, b) -> inr_rule a b) x)))
      []);

right_gtt ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 Maybe (Ta_list (Sum (Maybe (Term a b)) (Maybe (Term a b))) a,
                         Ta_list (Sum (Maybe (Term a b)) (Maybe (Term a b))) a);
right_gtt r =
  bind (rtrancl_gtt r)
    (\ (a, b) ->
      gTT_comp_impl (map_ta_list Inl id a, map_ta_list Inl id b)
        (map_ta_list Inr id b, map_ta_list Inr id a));

ctxt_compose :: forall a b. Ctxt a b -> Ctxt a b -> Ctxt a b;
ctxt_compose Hole d = d;
ctxt_compose (More f ss1 c ss2) d = More f ss1 (ctxt_compose c d) ss2;

lv_trs_to_gtt_impl ::
  forall a b.
    (Compare_order a,
      Compare_order b) => Rbta (a, Nat) () ->
                            Rbta (Term a b, Term a b) () ->
                              ((Rbta (Sum (Term a ()) (Term a ())) (),
                                 (Rbta (Ta_rule (Sum (Term a ()) (Term a ())) a)
                                    (),
                                   ([(Sum (Term a ()) (Term a ()),
                                       Sum (Term a ()) (Term a ()))],
                                     (Rbta (Sum (Term a ()) (Term a ())) (),
                                       (Rbta (a, Nat)
  (Rbta ([Sum (Term a ()) (Term a ())], Sum (Term a ()) (Term a ())) ()),
 (Bool,
   (Sum (Term a ()) (Term a ()) -> Rbta (Sum (Term a ()) (Term a ())) (),
     Sum (Term a ()) (Term a ()) ->
       Rbta (Sum (Term a ()) (Term a ())) ()))))))),
                                (Rbta (Sum (Term a ()) (Term a ())) (),
                                  (Rbta (Ta_rule (Sum (Term a ()) (Term a ()))
  a)
                                     (),
                                    ([(Sum (Term a ()) (Term a ()),
Sum (Term a ()) (Term a ()))],
                                      (Rbta (Sum (Term a ()) (Term a ())) (),
(Rbta (a, Nat)
   (Rbta ([Sum (Term a ()) (Term a ())], Sum (Term a ()) (Term a ())) ()),
  (Bool,
    (Sum (Term a ()) (Term a ()) -> Rbta (Sum (Term a ()) (Term a ())) (),
      Sum (Term a ()) (Term a ()) ->
        Rbta (Sum (Term a ()) (Term a ())) ()))))))));
lv_trs_to_gtt_impl f r = (trs_to_ta_L_impl f r, trs_to_ta_R_impl f r);

is_busy :: forall a b. Status a b -> Bool;
is_busy (Done uu) = False;
is_busy Changed = True;
is_busy Unchanged = True;

ta_size_rbt ::
  forall a b.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            (Nat, (Nat, Nat));
ta_size_rbt =
  (\ x ->
    (gen_card
       (\ xa ->
         foldli
           (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
             xa))
       (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
         (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
           (union_image_rs_code (ta_rules_impl x)
             (\ xa ->
               rbt_comp_insert compare (r_rhs xa) ()
                 (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                   (r_lhs_states xa))))
           (union_image_rs_code
             (case x of {
               (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                 rbt_bulkloada (map (\ k -> (k, ())) e);
             })
             (\ (xa, xb) ->
               rbt_comp_insert compare xa ()
                 (rbt_comp_insert compare xb () Empty))))
         (ta_final_impl x)),
      (gen_card
         (\ xa ->
           foldli
             (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
               xa))
         (ta_rules_impl x),
        gen_card (\ xa -> foldli (id xa)) (ta_eps_impl x))));

map_xoption :: forall a b. (a -> b) -> Xoption a -> Xoption b;
map_xoption f XNone = XNone;
map_xoption f (XSome x2) = XSome (f x2);

key_of_entry :: forall a b c d. (Rbta a b, Rbta c d) -> ([a], [c]);
key_of_entry (aa, a) = (keys aa, keys a);

status_result :: forall a b. Status a b -> Xoption (Term a b);
status_result (Done t) = t;
status_result Changed = XNone;
status_result Unchanged = XNone;

ta_lang_containment_impl ::
  forall a b c.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            (Rbta a (),
                              (Rbta (Ta_rule a b) (),
                                ([(a, a)],
                                  (Rbta a (),
                                    (Rbta (b, Nat) (Rbta ([a], a) ()),
                                      (Bool,
(a -> Rbta a (), a -> Rbta a ()))))))) ->
                              Xoption (Term b c);
ta_lang_containment_impl a b =
  the_res
    (let {
       x = Empty;
       _ = ta_final_impl a;
       _ = ta_final_impl b;
       xc = gen_image (map_iterator_dom . rm_iterateoi) []
              (glist_insert (prod_eq (comp2eq compare_res) equal_nat)) r_sym
              (ta_rules_impl a);
     } in dbind (dWHILET (\ xb -> is_busy (snd xb))
                  (\ (aa, _) ->
                    dbind (foldli xc (\ ab -> (case ab of {
        DSUCCEEDi -> False;
        DFAILi -> False;
        DRETURN xe -> is_busy (snd xe);
      }))
                            (\ xa s ->
                              dbind s
                                (\ sigma ->
                                  (case xa of {
                                    (aaa, ba) ->
                                      (case sigma of {
(ab, bb) ->
  foldli (product_lists (replicate ba (entries aa)))
    (\ ac -> (case ac of {
               DSUCCEEDi -> False;
               DFAILi -> False;
               DRETURN xg -> is_busy (snd xg);
             }))
    (\ xb sa ->
      dbind sa
        (\ (ac, bc) ->
          let {
            xh = map ((fst . id) . fst) xb;
            xi = let {
                   y = (\ sb -> impl_of (memo_rbt_rtrancl (ta_eps_impl a) sb));
                 } in (\ xaa xba ->
                        union_image_rs_code
                          (gen_filter (map_iterator_dom . rm_iterateoi) Empty
                            (\ k -> rbt_comp_insert compare_ta_rule k ())
                            (\ xca ->
                              comp2eq compare_res (r_root xca) xba &&
                                list_all2
                                  (\ k sb ->
                                    (case rbt_comp_lookup compare sb k of {
                                      Nothing -> False;
                                      Just _ -> True;
                                    }))
                                  (r_lhs_states xca) xaa)
                            (ta_rules_impl a))
                          (y . r_rhs))
                   xh
                   aaa;
          } in (if gen_isEmpty (gen_ball (map_iterator_dom . rm_iterateoi)) xi
                 then DRETURN (ac, bc)
                 else let {
                        xj = map ((snd . id) . fst) xb;
                        xk = let {
                               y = (\ sb ->
                                     impl_of
                                       (memo_rbt_rtrancl (ta_eps_impl b) sb));
                             } in (\ xaa xba ->
                                    union_image_rs_code
                                      (gen_filter
(map_iterator_dom . rm_iterateoi) Empty
(\ k -> rbt_comp_insert compare_ta_rule k ())
(\ xca ->
  comp2eq compare_res (r_root xca) xba &&
    list_all2 (\ k sb -> (case rbt_comp_lookup compare sb k of {
                           Nothing -> False;
                           Just _ -> True;
                         }))
      (r_lhs_states xca) xaa)
(ta_rules_impl b))
                                      (y . r_rhs))
                               xj
                               aaa;
                        xl = Fun aaa (map snd xb);
                      } in (if (case rbt_lookup
                                       (comp2lt
 (\ ad bd -> compare_res (key_of_entry ad) (key_of_entry bd)))
                                       (mapa (\ _ _ -> ()) ac) (id (xi, xk))
                                 of {
                                 Nothing -> False;
                                 Just _ -> True;
                               })
                             then DRETURN (ac, bc)
                             else (if id
(\ (xja, xka) ->
  not (gen_disjoint (map_iterator_dom . rm_iterateoi)
        (\ k sb -> (case rbt_comp_lookup compare sb k of {
                     Nothing -> False;
                     Just _ -> True;
                   }))
        xja (ta_final_impl a)) &&
    gen_disjoint (map_iterator_dom . rm_iterateoi)
      (\ k sb -> (case rbt_comp_lookup compare sb k of {
                   Nothing -> False;
                   Just _ -> True;
                 }))
      xka (ta_final_impl b))
(id (xi, xk))
                                    then DRETURN
   (rbt_insert
      (comp2lt (\ ad bd -> compare_res (key_of_entry ad) (key_of_entry bd)))
      (id (xi, xk)) xl ac,
     Done (XSome xl))
                                    else DRETURN
   (rbt_insert
      (comp2lt (\ ad bd -> compare_res (key_of_entry ad) (key_of_entry bd)))
      (id (xi, xk)) xl ac,
     Changed))))))
    (DRETURN (ab, bb));
                                      });
                                  })))
                            (DRETURN (aa, Unchanged)))
                      (\ xe -> DRETURN (case xe of {
 (_, Done _) -> xe;
 (_, Changed) -> xe;
 (xf, Unchanged) -> (xf, Done XNone);
                                       })))
                  (x, Changed))
            (\ xd ->
              DRETURN (map_xoption adapt_vars (status_result (snd xd)))));

ta_triple_to_impl ::
  forall a b c.
    (Compare a, Compare_order b,
      Compare c) => (Rbta a (), (Rbta (Ta_rule b c) (), [(b, b)])) ->
                      (Rbta a (),
                        (Rbta (Ta_rule b c) (),
                          ([(b, b)],
                            (Rbta b (),
                              (Rbta (c, Nat) (Rbta ([b], b) ()),
                                (Bool, (b -> Rbta b (), b -> Rbta b ())))))));
ta_triple_to_impl = (\ (f, a) -> (case a of {
                                   (aa, b) -> ta_make_code f aa b;
                                 }));

ta_list_to_triple ::
  forall a b.
    (Compare_order a, Eq a,
      Compare_order b) => Ta_list a b ->
                            (Rbta a (), (Rbta (Ta_rule a b) (), [(a, a)]));
ta_list_to_triple a =
  (rbt_bulkloada (map (\ k -> (k, ())) (tal_final a)),
    (rbt_bulkloada (map (\ k -> (k, ())) (tal_rules a)),
      remdups_sort (tal_eps a)));

cr_procedure ::
  [(Term [Nat] [Nat], Term [Nat] [Nat])] ->
    Maybe (Term (Maybe [Nat], Maybe [Nat]) ());
cr_procedure r =
  bind (left_gtt r)
    (\ a ->
      bind (right_gtt r)
        (\ b ->
          let {
            f = rbt_bulkloada
                  (map (\ k -> (k, ())) (concatMap funas_rule_list r));
            aa = (ta_triple_to_impl . gTT_to_RR2_impl f)
                   (map_prod (ta_triple_to_impl . ta_list_to_triple)
                     (ta_triple_to_impl . ta_list_to_triple) a);
            ba = (ta_triple_to_impl . gTT_to_RR2_impl f)
                   (map_prod (ta_triple_to_impl . ta_list_to_triple)
                     (ta_triple_to_impl . ta_list_to_triple) b);
          } in (case ta_lang_containment_impl aa ba of {
                 XNone -> Nothing;
                 XSome ab -> Just ab;
               })));

ta_final_update_impl ::
  forall a b.
    (Compare_order a,
      Compare_order b) => (Rbta a () -> Rbta a ()) ->
                            (Rbta a (),
                              (Rbta (Ta_rule a b) (),
                                ([(a, a)],
                                  (Rbta a (),
                                    (Rbta (b, Nat) (Rbta ([a], a) ()),
                                      (Bool,
(a -> Rbta a (), a -> Rbta a ()))))))) ->
                              (Rbta a (),
                                (Rbta (Ta_rule a b) (),
                                  ([(a, a)],
                                    (Rbta a (),
                                      (Rbta (b, Nat) (Rbta ([a], a) ()),
(Bool, (a -> Rbta a (), a -> Rbta a ())))))));
ta_final_update_impl =
  (\ x xa ->
    ta_make_code (x (ta_final_impl xa)) (ta_rules_impl xa) (ta_eps_impl xa));

ta_only_res_wits_code ::
  forall a b c d.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            Rbta a (Term c d) ->
                              (Rbta a (),
                                (Rbta (Ta_rule a b) (),
                                  ([(a, a)],
                                    (Rbta a (),
                                      (Rbta (b, Nat) (Rbta ([a], a) ()),
(Bool, (a -> Rbta a (), a -> Rbta a ())))))));
ta_only_res_wits_code a b =
  let {
    y = gen_filter (map_iterator_dom . rm_iterateoi) Empty
          (\ k -> rbt_comp_insert compare k ())
          (\ xb -> not (is_None (rbt_comp_lookup compare b xb)))
          (ta_final_impl a);
    y_a = gen_filter (map_iterator_dom . rm_iterateoi) Empty
            (\ k -> rbt_comp_insert compare_ta_rule k ())
            (\ xb ->
              list_all_rec
                (\ xc -> not (is_None (rbt_comp_lookup compare b xc)))
                (r_lhs_states xb))
            (ta_rules_impl a);
    aa = filter (\ xb -> not (is_None (rbt_comp_lookup compare b (fst xb))))
           (ta_eps_impl a);
  } in ta_make_code y y_a aa;

ta_eps_cl_impl ::
  forall a b c d e f g h i. (a, (b, (c, (d, (e, (f, (g -> h, i))))))) -> g -> h;
ta_eps_cl_impl (f, (r, (e, (rhs, (idx, (det, (efcl, eicl))))))) q = efcl q;

next_res_wit_code ::
  forall a b c.
    (Compare a,
      Compare b) => Rbta (Ta_rule a b) () ->
                      Rbta a (Term b c) -> Maybe (a, Term b c);
next_res_wit_code r m =
  (map_iterator_dom . rm_iterateoi) r is_None
    (\ x _ ->
      (case x of {
        TA_rule xb xc xd ->
          bind (mapM (rbt_comp_lookup compare m) xc)
            (\ xe -> Just (xd, Fun xb xe));
      }))
    Nothing;

update_all_code ::
  forall a b. (Compare a) => Rbta a b -> Rbta a () -> b -> Rbta a b;
update_all_code m s v =
  (map_iterator_dom . rm_iterateoi) s (\ _ -> True)
    (\ x -> rbt_comp_insert compare x v) m;

res_wits_code ::
  forall a b c.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            Rbta a (Term b c);
res_wits_code tAi =
  let {
    x = (ta_rules_impl tAi, Empty);
  } in (case while (\ (xb, _) ->
                     not (gen_isEmpty
                           (gen_ball (map_iterator_dom . rm_iterateoi)) xb))
               (\ (a, b) ->
                 (case next_res_wit_code a b of {
                   Nothing -> (Empty, b);
                   Just (aa, ba) ->
                     let {
                       xd = ta_eps_cl_impl tAi aa;
                       xe = update_all_code b xd ba;
                       xf = gen_filter (map_iterator_dom . rm_iterateoi) Empty
                              (\ k -> rbt_comp_insert compare_ta_rule k ())
                              (\ xf ->
                                not (case rbt_comp_lookup compare xd (r_rhs xf)
                                      of {
                                      Nothing -> False;
                                      Just _ -> True;
                                    }))
                              a;
                     } in (xf, xe);
                 }))
               x
         of {
         (_, b) -> b;
       });

ta_only_res_code ::
  forall a b.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            (Rbta a (),
                              (Rbta (Ta_rule a b) (),
                                ([(a, a)],
                                  (Rbta a (),
                                    (Rbta (b, Nat) (Rbta ([a], a) ()),
                                      (Bool,
(a -> Rbta a (), a -> Rbta a ())))))));
ta_only_res_code ta =
  let {
    a = (res_wits_code ::
          (Rbta a (),
            (Rbta (Ta_rule a b) (),
              ([(a, a)],
                (Rbta a (),
                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                    (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
            Rbta a (Term b ()))
          ta;
  } in (ta_only_res_wits_code ::
         (Rbta a (),
           (Rbta (Ta_rule a b) (),
             ([(a, a)],
               (Rbta a (),
                 (Rbta (b, Nat) (Rbta ([a], a) ()),
                   (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
           Rbta a (Term b ()) ->
             (Rbta a (),
               (Rbta (Ta_rule a b) (),
                 ([(a, a)],
                   (Rbta a (),
                     (Rbta (b, Nat) (Rbta ([a], a) ()),
                       (Bool, (a -> Rbta a (), a -> Rbta a ()))))))))
         ta a;

ta_only_prs_wits_code ::
  forall a b c d.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            Rbta a (Ctxt c d) ->
                              (Rbta a (),
                                (Rbta (Ta_rule a b) (),
                                  ([(a, a)],
                                    (Rbta a (),
                                      (Rbta (b, Nat) (Rbta ([a], a) ()),
(Bool, (a -> Rbta a (), a -> Rbta a ())))))));
ta_only_prs_wits_code a b =
  let {
    y = gen_filter (map_iterator_dom . rm_iterateoi) Empty
          (\ k -> rbt_comp_insert compare k ())
          (\ xb -> not (is_None (rbt_comp_lookup compare b xb)))
          (ta_final_impl a);
    y_a = gen_filter (map_iterator_dom . rm_iterateoi) Empty
            (\ k -> rbt_comp_insert compare_ta_rule k ())
            (\ xb -> not (is_None (rbt_comp_lookup compare b (r_rhs xb))))
            (ta_rules_impl a);
    aa = filter (\ xb -> not (is_None (rbt_comp_lookup compare b (snd xb))))
           (ta_eps_impl a);
  } in ta_make_code y y_a aa;

ta_eps_icl_impl ::
  forall a b c d e f g h i. (a, (b, (c, (d, (e, (f, (g, h -> i))))))) -> h -> i;
ta_eps_icl_impl (f, (r, (e, (rhs, (idx, (det, (efcl, eicl))))))) q = eicl q;

prs_wits_code ::
  forall a b.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            Rbta a (Ctxt b a);
prs_wits_code tAi =
  let {
    x = update_all_code Empty
          (union_image_rs_code (ta_final_impl tAi) (ta_eps_icl_impl tAi)) Hole;
    xa = (False, (ta_rules_impl tAi, x));
  } in (case while (\ (xb, (_, _)) -> not xb)
               (\ (_, (aa, ba)) ->
                 (map_iterator_dom . rm_iterateoi) aa (\ _ -> True)
                   (\ xc (ab, (ac, bc)) ->
                     (case rbt_comp_lookup compare bc (r_rhs xc) of {
                       Nothing ->
                         (ab, (rbt_comp_insert compare_ta_rule xc () ac, bc));
                       Just xd ->
                         (False,
                           (ac, (case xc of {
                                  TA_rule xj xk _ ->
                                    rec_list (\ _ xn _ _ _ -> xn)
                                      (\ xm xn xo xp xq xr xs xt ->
let {
  y_b = update_all_code xq (ta_eps_icl_impl xp (the_Var xm))
          (ctxt_compose xr (More xs xt Hole xn));
} in xo xp y_b xr xs (xt ++ [xm]))
                                      (map Var xk) tAi bc xd xj [];
                                })));
                     }))
                   (True, (Empty, ba)))
               xa
         of {
         (_, (_, ba)) -> ba;
       });

ta_only_prs_code ::
  forall a b.
    (Compare_order a,
      Compare_order b) => (Rbta a (),
                            (Rbta (Ta_rule a b) (),
                              ([(a, a)],
                                (Rbta a (),
                                  (Rbta (b, Nat) (Rbta ([a], a) ()),
                                    (Bool,
                                      (a -> Rbta a (), a -> Rbta a ()))))))) ->
                            (Rbta a (),
                              (Rbta (Ta_rule a b) (),
                                ([(a, a)],
                                  (Rbta a (),
                                    (Rbta (b, Nat) (Rbta ([a], a) ()),
                                      (Bool,
(a -> Rbta a (), a -> Rbta a ())))))));
ta_only_prs_code ta = let {
                        a = prs_wits_code ta;
                      } in ta_only_prs_wits_code ta a;

trim_gtt_impl ::
  forall a b.
    (Compare_order a,
      Compare_order b) => ((Rbta a (),
                             (Rbta (Ta_rule a b) (),
                               ([(a, a)],
                                 (Rbta a (),
                                   (Rbta (b, Nat) (Rbta ([a], a) ()),
                                     (Bool,
                                       (a -> Rbta a (), a -> Rbta a ()))))))),
                            (Rbta a (),
                              (Rbta (Ta_rule a b) (),
                                ([(a, a)],
                                  (Rbta a (),
                                    (Rbta (b, Nat) (Rbta ([a], a) ()),
                                      (Bool,
(a -> Rbta a (), a -> Rbta a ())))))))) ->
                            ((Rbta a (),
                               (Rbta (Ta_rule a b) (),
                                 ([(a, a)],
                                   (Rbta a (),
                                     (Rbta (b, Nat) (Rbta ([a], a) ()),
                                       (Bool,
 (a -> Rbta a (), a -> Rbta a ()))))))),
                              (Rbta a (),
                                (Rbta (Ta_rule a b) (),
                                  ([(a, a)],
                                    (Rbta a (),
                                      (Rbta (b, Nat) (Rbta ([a], a) ()),
(Bool, (a -> Rbta a (), a -> Rbta a ()))))))));
trim_gtt_impl x =
  (case (ta_final_update_impl
           (\ _ ->
             gen_inter
               (\ xa ->
                 foldli
                   (it_to_list
                     (map_iterator_dom . foldli . it_to_list rm_iterateoi) xa))
               (\ k s -> (case rbt_comp_lookup compare s k of {
                           Nothing -> False;
                           Just _ -> True;
                         }))
               (\ k -> rbt_comp_insert compare k ()) Empty
               (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                 (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                   (union_image_rs_code
                     (ta_rules_impl
                       (ta_final_update_impl (\ _ -> Empty)
                         (fst (case x of {
                                (xb, xc) ->
                                  (ta_only_res_code xb, ta_only_res_code xc);
                              }))))
                     (\ xa ->
                       rbt_comp_insert compare (r_rhs xa) ()
                         (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                           (r_lhs_states xa))))
                   (union_image_rs_code
                     (case ta_final_update_impl (\ _ -> Empty)
                             (fst (case x of {
                                    (xb, xc) ->
                                      (ta_only_res_code xb,
ta_only_res_code xc);
                                  }))
                       of {
                       (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                         rbt_bulkloada (map (\ k -> (k, ())) e);
                     })
                     (\ (xa, xb) ->
                       rbt_comp_insert compare xa ()
                         (rbt_comp_insert compare xb () Empty))))
                 (ta_final_impl
                   (ta_final_update_impl (\ _ -> Empty)
                     (fst (case x of {
                            (xb, xc) ->
                              (ta_only_res_code xb, ta_only_res_code xc);
                          })))))
               (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                 (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                   (union_image_rs_code
                     (ta_rules_impl
                       (ta_final_update_impl (\ _ -> Empty)
                         (snd (case x of {
                                (xb, xc) ->
                                  (ta_only_res_code xb, ta_only_res_code xc);
                              }))))
                     (\ xa ->
                       rbt_comp_insert compare (r_rhs xa) ()
                         (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                           (r_lhs_states xa))))
                   (union_image_rs_code
                     (case ta_final_update_impl (\ _ -> Empty)
                             (snd (case x of {
                                    (xb, xc) ->
                                      (ta_only_res_code xb,
ta_only_res_code xc);
                                  }))
                       of {
                       (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                         rbt_bulkloada (map (\ k -> (k, ())) e);
                     })
                     (\ (xa, xb) ->
                       rbt_comp_insert compare xa ()
                         (rbt_comp_insert compare xb () Empty))))
                 (ta_final_impl
                   (ta_final_update_impl (\ _ -> Empty)
                     (snd (case x of {
                            (xb, xc) ->
                              (ta_only_res_code xb, ta_only_res_code xc);
                          }))))))
           (fst (case x of {
                  (xa, xb) -> (ta_only_res_code xa, ta_only_res_code xb);
                })),
          ta_final_update_impl
            (\ _ ->
              gen_inter
                (\ xa ->
                  foldli
                    (it_to_list
                      (map_iterator_dom . foldli . it_to_list rm_iterateoi) xa))
                (\ k s -> (case rbt_comp_lookup compare s k of {
                            Nothing -> False;
                            Just _ -> True;
                          }))
                (\ k -> rbt_comp_insert compare k ()) Empty
                (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                  (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                    (union_image_rs_code
                      (ta_rules_impl
                        (ta_final_update_impl (\ _ -> Empty)
                          (fst (case x of {
                                 (xb, xc) ->
                                   (ta_only_res_code xb, ta_only_res_code xc);
                               }))))
                      (\ xa ->
                        rbt_comp_insert compare (r_rhs xa) ()
                          (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                            (r_lhs_states xa))))
                    (union_image_rs_code
                      (case ta_final_update_impl (\ _ -> Empty)
                              (fst (case x of {
                                     (xb, xc) ->
                                       (ta_only_res_code xb,
 ta_only_res_code xc);
                                   }))
                        of {
                        (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                          rbt_bulkloada (map (\ k -> (k, ())) e);
                      })
                      (\ (xa, xb) ->
                        rbt_comp_insert compare xa ()
                          (rbt_comp_insert compare xb () Empty))))
                  (ta_final_impl
                    (ta_final_update_impl (\ _ -> Empty)
                      (fst (case x of {
                             (xb, xc) ->
                               (ta_only_res_code xb, ta_only_res_code xc);
                           })))))
                (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                  (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                    (union_image_rs_code
                      (ta_rules_impl
                        (ta_final_update_impl (\ _ -> Empty)
                          (snd (case x of {
                                 (xb, xc) ->
                                   (ta_only_res_code xb, ta_only_res_code xc);
                               }))))
                      (\ xa ->
                        rbt_comp_insert compare (r_rhs xa) ()
                          (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                            (r_lhs_states xa))))
                    (union_image_rs_code
                      (case ta_final_update_impl (\ _ -> Empty)
                              (snd (case x of {
                                     (xb, xc) ->
                                       (ta_only_res_code xb,
 ta_only_res_code xc);
                                   }))
                        of {
                        (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                          rbt_bulkloada (map (\ k -> (k, ())) e);
                      })
                      (\ (xa, xb) ->
                        rbt_comp_insert compare xa ()
                          (rbt_comp_insert compare xb () Empty))))
                  (ta_final_impl
                    (ta_final_update_impl (\ _ -> Empty)
                      (snd (case x of {
                             (xb, xc) ->
                               (ta_only_res_code xb, ta_only_res_code xc);
                           }))))))
            (snd (case x of {
                   (xa, xb) -> (ta_only_res_code xa, ta_only_res_code xb);
                 })))
    of {
    (xa, xb) -> (ta_only_prs_code xa, ta_only_prs_code xb);
  });

gTT_to_RR2_rbt ::
  forall a b.
    (Compare_order a,
      Compare_order b) => Rbta (a, Nat) () ->
                            ((Rbta b (),
                               (Rbta (Ta_rule b a) (),
                                 ([(b, b)],
                                   (Rbta b (),
                                     (Rbta (a, Nat) (Rbta ([b], b) ()),
                                       (Bool,
 (b -> Rbta b (), b -> Rbta b ()))))))),
                              (Rbta b (),
                                (Rbta (Ta_rule b a) (),
                                  ([(b, b)],
                                    (Rbta b (),
                                      (Rbta (a, Nat) (Rbta ([b], b) ()),
(Bool, (b -> Rbta b (), b -> Rbta b ())))))))) ->
                              (Rbta (Maybe (Maybe b, Maybe b)) (),
                                (Rbta (Ta_rule (Maybe (Maybe b, Maybe b))
(Maybe a, Maybe a))
                                   (),
                                  ([(Maybe (Maybe b, Maybe b),
                                      Maybe (Maybe b, Maybe b))],
                                    (Rbta (Maybe (Maybe b, Maybe b)) (),
                                      (Rbta ((Maybe a, Maybe a), Nat)
 (Rbta ([Maybe (Maybe b, Maybe b)], Maybe (Maybe b, Maybe b)) ()),
(Bool,
  (Maybe (Maybe b, Maybe b) -> Rbta (Maybe (Maybe b, Maybe b)) (),
    Maybe (Maybe b, Maybe b) -> Rbta (Maybe (Maybe b, Maybe b)) ())))))));
gTT_to_RR2_rbt =
  (\ x xa ->
    ta_make_code (rbt_comp_insert compare_option Nothing () Empty)
      (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
        (gen_image
          (\ xb ->
            foldli
              (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                xb))
          Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
          (map_ta_rule Just id)
          (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
            (rbt_comp_union_with_key compare_ta_rule (\ _ _ rv -> rv)
              (gen_image
                (\ xb ->
                  foldli
                    (it_to_list
                      (map_iterator_dom . foldli . it_to_list rm_iterateoi) xb))
                Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
                (\ (TA_rule xb xc xd) ->
                  TA_rule (Just xb, Nothing)
                    (map (\ xe -> (Just xe, Nothing)) xc) (Just xd, Nothing))
                (ta_rules_impl (fst xa)))
              (gen_image
                (\ xb ->
                  foldli
                    (it_to_list
                      (map_iterator_dom . foldli . it_to_list rm_iterateoi) xb))
                Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
                (\ (TA_rule xb xc xd) ->
                  TA_rule (Nothing, Just xb)
                    (map (\ xe -> (Nothing, Just xe)) xc) (Nothing, Just xd))
                (ta_rules_impl (snd xa))))
            (gen_image (\ xb -> foldli (id xb)) Empty
              (\ k -> rbt_comp_insert compare_ta_rule k ())
              (\ (xb, a) ->
                (case a of {
                  TA_rule aa b c ->
                    (case xb of {
                      TA_rule xc xd xe ->
                        (\ xf xg xh ->
                          TA_rule (Just xc, Just xf) (zip_fill xd xg)
                            (Just xe, Just xh));
                    })
                      aa
                      b
                      c;
                }))
              (gen_Sigma
                (\ xb ->
                  foldli
                    (it_to_list
                      (map_iterator_dom . foldli . it_to_list rm_iterateoi) xb))
                (\ xb ->
                  foldli
                    (it_to_list
                      (map_iterator_dom . foldli . it_to_list rm_iterateoi) xb))
                [] (glist_insert
                     (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                (ta_rules_impl (fst xa)) (\ _ -> ta_rules_impl (snd xa))))))
        (gen_image
          (\ xb ->
            foldli
              (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                xb))
          Empty (\ k -> rbt_comp_insert compare_ta_rule k ())
          (\ (xb, xc) ->
            TA_rule (Just xb, Just xb) (replicate xc Nothing) Nothing)
          x))
      (gen_union (\ xb -> foldli (id xb))
        (glist_insert
          (prod_eq
            (option_eq
              (prod_eq (option_eq (comp2eq compare_res))
                (option_eq (comp2eq compare_res))))
            (option_eq
              (prod_eq (option_eq (comp2eq compare_res))
                (option_eq (comp2eq compare_res))))))
        (gen_image (\ xb -> foldli (id xb)) []
          (glist_insert
            (prod_eq
              (option_eq
                (prod_eq (option_eq (comp2eq compare_res))
                  (option_eq (comp2eq compare_res))))
              (option_eq
                (prod_eq (option_eq (comp2eq compare_res))
                  (option_eq (comp2eq compare_res))))))
          (\ (xb, xc) -> (Just xb, Just xc))
          (gen_union (\ xb -> foldli (id xb))
            (glist_insert
              (prod_eq
                (prod_eq (option_eq (comp2eq compare_res))
                  (option_eq (comp2eq compare_res)))
                (prod_eq (option_eq (comp2eq compare_res))
                  (option_eq (comp2eq compare_res)))))
            (gen_image (\ xb -> foldli (id xb)) []
              (glist_insert
                (prod_eq
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res)))
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res)))))
              (\ (a, b) ->
                (case a of {
                  (xb, xc) -> (\ xd -> ((Just xb, xd), (Just xc, xd)));
                })
                  b)
              (concatMap
                (\ xb ->
                  map (\ a -> (xb, a))
                    (gen_union (\ xc -> foldli (id xc))
                      (glist_insert (option_eq (comp2eq compare_res))) [Nothing]
                      (gen_image
                        (\ xc ->
                          foldli
                            (it_to_list
                              (map_iterator_dom .
                                foldli . it_to_list rm_iterateoi)
                              xc))
                        [] (glist_insert (option_eq (comp2eq compare_res))) Just
                        (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                          (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                            (union_image_rs_code (ta_rules_impl (snd xa))
                              (\ xaa ->
                                rbt_comp_insert compare (r_rhs xaa) ()
                                  (gen_set Empty
                                    (\ k -> rbt_comp_insert compare k ())
                                    (r_lhs_states xaa))))
                            (union_image_rs_code
                              (case snd xa of {
                                (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                                  rbt_bulkloada (map (\ k -> (k, ())) e);
                              })
                              (\ (xaa, xba) ->
                                rbt_comp_insert compare xaa ()
                                  (rbt_comp_insert compare xba () Empty))))
                          (ta_final_impl (snd xa))))))
                (ta_eps_impl (fst xa))))
            (gen_image (\ xb -> foldli (id xb)) []
              (glist_insert
                (prod_eq
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res)))
                  (prod_eq (option_eq (comp2eq compare_res))
                    (option_eq (comp2eq compare_res)))))
              (\ (xb, (xc, xd)) -> ((xb, Just xc), (xb, Just xd)))
              (concatMap (\ xb -> map (\ a -> (xb, a)) (ta_eps_impl (snd xa)))
                (gen_union (\ xb -> foldli (id xb))
                  (glist_insert (option_eq (comp2eq compare_res))) [Nothing]
                  (gen_image
                    (\ xb ->
                      foldli
                        (it_to_list
                          (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                          xb))
                    [] (glist_insert (option_eq (comp2eq compare_res))) Just
                    (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                      (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                        (union_image_rs_code (ta_rules_impl (fst xa))
                          (\ xaa ->
                            rbt_comp_insert compare (r_rhs xaa) ()
                              (gen_set Empty
                                (\ k -> rbt_comp_insert compare k ())
                                (r_lhs_states xaa))))
                        (union_image_rs_code
                          (case fst xa of {
                            (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                              rbt_bulkloada (map (\ k -> (k, ())) e);
                          })
                          (\ (xaa, xb) ->
                            rbt_comp_insert compare xaa ()
                              (rbt_comp_insert compare xb () Empty))))
                      (ta_final_impl (fst xa)))))))))
        (gen_image
          (\ xb ->
            foldli
              (it_to_list (map_iterator_dom . foldli . it_to_list rm_iterateoi)
                xb))
          [] (glist_insert
               (prod_eq
                 (option_eq
                   (prod_eq (option_eq (comp2eq compare_res))
                     (option_eq (comp2eq compare_res))))
                 (option_eq
                   (prod_eq (option_eq (comp2eq compare_res))
                     (option_eq (comp2eq compare_res))))))
          (\ xb -> (Just (Just xb, Just xb), Nothing))
          (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
            (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
              (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                (union_image_rs_code (ta_rules_impl (fst xa))
                  (\ xaa ->
                    rbt_comp_insert compare (r_rhs xaa) ()
                      (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                        (r_lhs_states xaa))))
                (union_image_rs_code
                  (case fst xa of {
                    (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                      rbt_bulkloada (map (\ k -> (k, ())) e);
                  })
                  (\ (xaa, xb) ->
                    rbt_comp_insert compare xaa ()
                      (rbt_comp_insert compare xb () Empty))))
              (ta_final_impl (fst xa)))
            (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
              (rbt_comp_union_with_key compare (\ _ _ rv -> rv)
                (union_image_rs_code (ta_rules_impl (snd xa))
                  (\ xaa ->
                    rbt_comp_insert compare (r_rhs xaa) ()
                      (gen_set Empty (\ k -> rbt_comp_insert compare k ())
                        (r_lhs_states xaa))))
                (union_image_rs_code
                  (case snd xa of {
                    (_, (_, (e, (_, (_, (_, (_, _))))))) ->
                      rbt_bulkloada (map (\ k -> (k, ())) e);
                  })
                  (\ (xaa, xb) ->
                    rbt_comp_insert compare xaa ()
                      (rbt_comp_insert compare xb () Empty))))
              (ta_final_impl (snd xa)))))));

delta_trancl_infer0_rbt ::
  forall a b c d e f g h i j k l m n o p q r s.
    (Eq c) => (a, (Rbta (Ta_rule b c) d, (e, (f, (g, (h, (i, j))))))) ->
                (k, (Rbta (Ta_rule l c) m, (n, (o, (p, (q, (r, s))))))) ->
                  [(b, l)];
delta_trancl_infer0_rbt a b = delta_epsilon_infer0_rbt a b;

delta_trancl_infer1_rbt ::
  forall a b c d e f g h i j k l m n o p q.
    (Eq b,
      Eq c) => (a, (Rbta (Ta_rule b c) d, ([(b, b)], (e, (f, (g, (h, i))))))) ->
                 (j, (Rbta (Ta_rule b c) k,
                       ([(b, b)], (l, (m, (n, (o, p))))))) ->
                   (b, b) -> Rbta (b, b) q -> [(b, b)];
delta_trancl_infer1_rbt a b pq x =
  delta_epsilon_infer1_rbt a b pq x ++
    map_filter
      (\ xa ->
        (if (case xa of {
              (_, p) -> p == fst pq;
            })
          then Just (case xa of {
                      (r, _) -> (r, snd pq);
                    })
          else Nothing))
      (keys x) ++
      map_filter
        (\ xa ->
          (if (case xa of {
                (q, _) -> q == snd pq;
              })
            then Just (case xa of {
                        (_, aa) -> (fst pq, aa);
                      })
            else Nothing))
        (pq : keys x);

delta_trancl_rbt_0 ::
  forall a b.
    (Compare_order a, Eq a, Compare_order b,
      Eq b) => (Rbta a (),
                 (Rbta (Ta_rule a b) (),
                   ([(a, a)],
                     (Rbta a (),
                       (Rbta (b, Nat) (Rbta ([a], a) ()),
                         (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                 (Rbta a (),
                   (Rbta (Ta_rule a b) (),
                     ([(a, a)],
                       (Rbta a (),
                         (Rbta (b, Nat) (Rbta ([a], a) ()),
                           (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                   ((a, a), Rbta (a, a) ()) -> Dres (Rbta (a, a) ());
delta_trancl_rbt_0 a b x =
  (case x of {
    (aa, ba) ->
      (if map2set_memb (\ k t -> rbt_lookupa t k) aa ba then DRETURN ba
        else foldl (\ s xa -> dbind s (\ sa -> delta_trancl_rbt_0 a b (xa, sa)))
               (DRETURN (map2set_insert rbt_inserta aa ba))
               (delta_trancl_infer1_rbt a b aa ba));
  });

delta_trancl_rbt ::
  forall a b.
    (Compare_order a, Eq a, Compare_order b,
      Eq b) => (Rbta a (),
                 (Rbta (Ta_rule a b) (),
                   ([(a, a)],
                     (Rbta a (),
                       (Rbta (b, Nat) (Rbta ([a], a) ()),
                         (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                 (Rbta a (),
                   (Rbta (Ta_rule a b) (),
                     ([(a, a)],
                       (Rbta a (),
                         (Rbta (b, Nat) (Rbta ([a], a) ()),
                           (Bool, (a -> Rbta a (), a -> Rbta a ()))))))) ->
                   Dres (Rbta (a, a) ());
delta_trancl_rbt a b =
  foldl (\ s x -> dbind s (\ sa -> delta_trancl_rbt_0 a b (x, sa)))
    (DRETURN Empty) (delta_trancl_infer0_rbt a b);

gTT_trancl_rbt ::
  forall a b.
    (Compare_order a, Eq a, Compare_order b,
      Eq b) => ((Rbta a (),
                  (Rbta (Ta_rule a b) (),
                    ([(a, a)],
                      (Rbta a (),
                        (Rbta (b, Nat) (Rbta ([a], a) ()),
                          (Bool, (a -> Rbta a (), a -> Rbta a ()))))))),
                 (Rbta a (),
                   (Rbta (Ta_rule a b) (),
                     ([(a, a)],
                       (Rbta a (),
                         (Rbta (b, Nat) (Rbta ([a], a) ()),
                           (Bool, (a -> Rbta a (), a -> Rbta a ())))))))) ->
                 Dres ((Rbta a (),
                         (Rbta (Ta_rule a b) (),
                           ([(a, a)],
                             (Rbta a (),
                               (Rbta (b, Nat) (Rbta ([a], a) ()),
                                 (Bool, (a -> Rbta a (), a -> Rbta a ()))))))),
                        (Rbta a (),
                          (Rbta (Ta_rule a b) (),
                            ([(a, a)],
                              (Rbta a (),
                                (Rbta (b, Nat) (Rbta ([a], a) ()),
                                  (Bool,
                                    (a -> Rbta a (), a -> Rbta a ()))))))));
gTT_trancl_rbt g =
  dbind (delta_trancl_rbt (snd g) (fst g))
    (\ a ->
      dbind (delta_trancl_rbt (fst g) (snd g))
        (\ a_a ->
          DRETURN
            (ta_make_code Empty (ta_rules_impl (fst g))
               (gen_union (\ x -> foldli (id x))
                 (glist_insert
                   (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                 (ta_eps_impl (fst g)) (keys a)),
              ta_make_code Empty (ta_rules_impl (snd g))
                (gen_union (\ x -> foldli (id x))
                  (glist_insert
                    (prod_eq (comp2eq compare_res) (comp2eq compare_res)))
                  (ta_eps_impl (snd g)) (keys a_a)))));

lv_gcr_procedure_rbt ::
  forall a b.
    (Compare_order a, Eq a,
      Compare_order b) => Rbta (a, Nat) () ->
                            Rbta (Term a b, Term a b) () -> Dres Bool;
lv_gcr_procedure_rbt x xa =
  dbind (gTT_trancl_rbt (lv_trs_to_gtt_impl x xa))
    (\ ab ->
      dbind (gTT_comp_rbt
              (map_prod
                (\ ac ->
                  ta_make_code
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb -> (Inl xb, ()))) .
                       keys)
                      (ta_final_impl ac))
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb ->
                              ((case xb of {
                                 TA_rule g qs q ->
                                   TA_rule g (map Inl qs) (Inl q);
                               }),
                                ()))) .
                       keys)
                      (ta_rules_impl ac))
                    (map (\ (q, qa) -> (Inl q, Inl qa)) (ta_eps_impl ac)))
                (\ ac ->
                  ta_make_code
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb -> (Inl xb, ()))) .
                       keys)
                      (ta_final_impl ac))
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb ->
                              ((case xb of {
                                 TA_rule g qs q ->
                                   TA_rule g (map Inl qs) (Inl q);
                               }),
                                ()))) .
                       keys)
                      (ta_rules_impl ac))
                    (map (\ (q, qa) -> (Inl q, Inl qa)) (ta_eps_impl ac)))
                (swap ab))
              (map_prod
                (\ ac ->
                  ta_make_code
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb -> (Inr xb, ()))) .
                       keys)
                      (ta_final_impl ac))
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb ->
                              ((case xb of {
                                 TA_rule g qs q ->
                                   TA_rule g (map Inr qs) (Inr q);
                               }),
                                ()))) .
                       keys)
                      (ta_rules_impl ac))
                    (map (\ (q, qa) -> (Inr q, Inr qa)) (ta_eps_impl ac)))
                (\ ac ->
                  ta_make_code
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb -> (Inr xb, ()))) .
                       keys)
                      (ta_final_impl ac))
                    (((rbt_bulkload (comp2lt compare_res) .
                        map (\ xb ->
                              ((case xb of {
                                 TA_rule g qs q ->
                                   TA_rule g (map Inr qs) (Inr q);
                               }),
                                ()))) .
                       keys)
                      (ta_rules_impl ac))
                    (map (\ (q, qa) -> (Inr q, Inr qa)) (ta_eps_impl ac)))
                ab))
        (\ ac ->
          dbind (gTT_comp_rbt
                  (map_prod
                    (\ ad ->
                      ta_make_code
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb -> (Inr xb, ()))) .
                           keys)
                          (ta_final_impl ad))
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb ->
                                  ((case xb of {
                                     TA_rule g qs q ->
                                       TA_rule g (map Inr qs) (Inr q);
                                   }),
                                    ()))) .
                           keys)
                          (ta_rules_impl ad))
                        (map (\ (q, qa) -> (Inr q, Inr qa)) (ta_eps_impl ad)))
                    (\ ad ->
                      ta_make_code
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb -> (Inr xb, ()))) .
                           keys)
                          (ta_final_impl ad))
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb ->
                                  ((case xb of {
                                     TA_rule g qs q ->
                                       TA_rule g (map Inr qs) (Inr q);
                                   }),
                                    ()))) .
                           keys)
                          (ta_rules_impl ad))
                        (map (\ (q, qa) -> (Inr q, Inr qa)) (ta_eps_impl ad)))
                    ab)
                  (map_prod
                    (\ ad ->
                      ta_make_code
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb -> (Inl xb, ()))) .
                           keys)
                          (ta_final_impl ad))
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb ->
                                  ((case xb of {
                                     TA_rule g qs q ->
                                       TA_rule g (map Inl qs) (Inl q);
                                   }),
                                    ()))) .
                           keys)
                          (ta_rules_impl ad))
                        (map (\ (q, qa) -> (Inl q, Inl qa)) (ta_eps_impl ad)))
                    (\ ad ->
                      ta_make_code
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb -> (Inl xb, ()))) .
                           keys)
                          (ta_final_impl ad))
                        (((rbt_bulkload (comp2lt compare_res) .
                            map (\ xb ->
                                  ((case xb of {
                                     TA_rule g qs q ->
                                       TA_rule g (map Inl qs) (Inl q);
                                   }),
                                    ()))) .
                           keys)
                          (ta_rules_impl ad))
                        (map (\ (q, qa) -> (Inl q, Inl qa)) (ta_eps_impl ad)))
                    (swap ab)))
            (\ ad ->
              dbind (DRETURN
                      (ta_nat_impl (gTT_to_RR2_rbt x (trim_gtt_impl ac))))
                (\ ae ->
                  dbind (DRETURN
                          (ta_nat_impl (gTT_to_RR2_rbt x (trim_gtt_impl ad))))
                    (\ af ->
                      dbind (DRETURN ())
                        (\ _ ->
                          dbind (DRETURN ())
                            (\ _ ->
                              dbind (DRETURN
                                      ((ta_lang_containment_impl ::
 (Rbta Nat (),
   (Rbta (Ta_rule Nat (Maybe a, Maybe a)) (),
     ([(Nat, Nat)],
       (Rbta Nat (),
         (Rbta ((Maybe a, Maybe a), Nat) (Rbta ([Nat], Nat) ()),
           (Bool, (Nat -> Rbta Nat (), Nat -> Rbta Nat ()))))))) ->
   (Rbta Nat (),
     (Rbta (Ta_rule Nat (Maybe a, Maybe a)) (),
       ([(Nat, Nat)],
         (Rbta Nat (),
           (Rbta ((Maybe a, Maybe a), Nat) (Rbta ([Nat], Nat) ()),
             (Bool, (Nat -> Rbta Nat (), Nat -> Rbta Nat ()))))))) ->
     Xoption (Term (Maybe a, Maybe a) ()))
((ta_only_prs_code . ta_only_res_code) ae)
((ta_only_prs_code . ta_only_res_code) af)))
                                (\ ai -> DRETURN (case ai of {
           XNone -> True;
           XSome _ -> False;
         })))))))));

llrg_cr_procedure_wrap ::
  [([Nat], Nat)] -> [(Term [Nat] [Nat], Term [Nat] [Nat])] -> Answer;
llrg_cr_procedure_wrap f r =
  (if left_linear_trs (Set r) &&
        right_ground_trs (Set r) && subset (funas_trs (Set r)) (Set f)
    then (case lv_gcr_procedure_rbt
                 (rbt_bulkloada
                   (map (\ x -> (x, ()))
                     ((Nothing, zero_nat) : map (map_prod Just id) f)))
                 (rbt_bulkloada
                   (map (\ x -> (x, ()))
                     (map (map_prod (map_term Just (\ x -> x))
                            (map_term Just (\ x -> x)))
                       r)))
           of {
           DSUCCEEDi -> MAYBE;
           DFAILi -> MAYBE;
           DRETURN True -> YES;
           DRETURN False -> NO;
         })
    else MAYBE);

lv_gcr_procedure_wrap ::
  [([Nat], Nat)] -> [(Term [Nat] [Nat], Term [Nat] [Nat])] -> Answer;
lv_gcr_procedure_wrap f r =
  (if all (\ (l, ra) -> linear_term (Fun (error "undefined") [l, ra])) r &&
        subset (funas_trs (Set r)) (Set f)
    then (case lv_gcr_procedure_rbt (rbt_bulkloada (map (\ x -> (x, ())) f))
                 (rbt_bulkloada (map (\ x -> (x, ())) r))
           of {
           DSUCCEEDi -> MAYBE;
           DFAILi -> MAYBE;
           DRETURN True -> YES;
           DRETURN False -> NO;
         })
    else MAYBE);

}
