import qualified GCR as GCR

import qualified Data.Rewriting.Problem as P
import qualified Data.Rewriting.Rule as R
import qualified Data.Rewriting.Rules as Rs
import qualified Data.Rewriting.Term as T
import System.Environment
import Data.Char (ord)

main = do
    [f] <- getArgs
    p <- P.parseFileIO f
    let trs = P.allRules (P.rules p)
        trs' = map (\r -> (conv (R.lhs r), conv (R.rhs r))) trs
        cchr = GCR.nat_of_integer . fromIntegral . ord
        conv = T.fold GCR.Var GCR.Fun . T.map (map cchr) (map cchr)
        res = GCR.cr_procedure trs'
    if Rs.isGround trs then
        case res of
            Nothing -> putStrLn "YES"
            Just _ -> putStrLn "NO"
            -- Note that in principle we get a witness here, namely the ends of
            -- a non-joinable peak.
     else
        putStrLn "MAYBE"
